# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DdosBlackWhiteIpArgs', 'DdosBlackWhiteIp']

@pulumi.input_type
class DdosBlackWhiteIpArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 ip: pulumi.Input[str],
                 mask: pulumi.Input[int],
                 type: pulumi.Input[str]):
        """
        The set of arguments for constructing a DdosBlackWhiteIp resource.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] ip: ip list.
        :param pulumi.Input[int] mask: ip mask.
        :param pulumi.Input[str] type: ip type, black: black ip list, white: white ip list.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "mask", mask)
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Input[str]:
        """
        ip list.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def mask(self) -> pulumi.Input[int]:
        """
        ip mask.
        """
        return pulumi.get(self, "mask")

    @mask.setter
    def mask(self, value: pulumi.Input[int]):
        pulumi.set(self, "mask", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        ip type, black: black ip list, white: white ip list.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)


@pulumi.input_type
class _DdosBlackWhiteIpState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 mask: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DdosBlackWhiteIp resources.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] ip: ip list.
        :param pulumi.Input[int] mask: ip mask.
        :param pulumi.Input[str] type: ip type, black: black ip list, white: white ip list.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if mask is not None:
            pulumi.set(__self__, "mask", mask)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter
    def ip(self) -> Optional[pulumi.Input[str]]:
        """
        ip list.
        """
        return pulumi.get(self, "ip")

    @ip.setter
    def ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ip", value)

    @property
    @pulumi.getter
    def mask(self) -> Optional[pulumi.Input[int]]:
        """
        ip mask.
        """
        return pulumi.get(self, "mask")

    @mask.setter
    def mask(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "mask", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        ip type, black: black ip list, white: white ip list.
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class DdosBlackWhiteIp(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 mask: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a antiddos ddos black white ip

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ddos_black_white_ip = tencentcloud.antiddos.DdosBlackWhiteIp("ddosBlackWhiteIp",
            instance_id="bgp-xxxxxx",
            ip="1.2.3.5",
            mask=0,
            type="black")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        antiddos ddos_black_white_ip can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Antiddos/ddosBlackWhiteIp:DdosBlackWhiteIp ddos_black_white_ip ${instanceId}#${ip}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] ip: ip list.
        :param pulumi.Input[int] mask: ip mask.
        :param pulumi.Input[str] type: ip type, black: black ip list, white: white ip list.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DdosBlackWhiteIpArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a antiddos ddos black white ip

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ddos_black_white_ip = tencentcloud.antiddos.DdosBlackWhiteIp("ddosBlackWhiteIp",
            instance_id="bgp-xxxxxx",
            ip="1.2.3.5",
            mask=0,
            type="black")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        antiddos ddos_black_white_ip can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Antiddos/ddosBlackWhiteIp:DdosBlackWhiteIp ddos_black_white_ip ${instanceId}#${ip}
        ```

        :param str resource_name: The name of the resource.
        :param DdosBlackWhiteIpArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DdosBlackWhiteIpArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 ip: Optional[pulumi.Input[str]] = None,
                 mask: Optional[pulumi.Input[int]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DdosBlackWhiteIpArgs.__new__(DdosBlackWhiteIpArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if ip is None and not opts.urn:
                raise TypeError("Missing required property 'ip'")
            __props__.__dict__["ip"] = ip
            if mask is None and not opts.urn:
                raise TypeError("Missing required property 'mask'")
            __props__.__dict__["mask"] = mask
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
        super(DdosBlackWhiteIp, __self__).__init__(
            'tencentcloud:Antiddos/ddosBlackWhiteIp:DdosBlackWhiteIp',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            ip: Optional[pulumi.Input[str]] = None,
            mask: Optional[pulumi.Input[int]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'DdosBlackWhiteIp':
        """
        Get an existing DdosBlackWhiteIp resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: instance id.
        :param pulumi.Input[str] ip: ip list.
        :param pulumi.Input[int] mask: ip mask.
        :param pulumi.Input[str] type: ip type, black: black ip list, white: white ip list.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DdosBlackWhiteIpState.__new__(_DdosBlackWhiteIpState)

        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["ip"] = ip
        __props__.__dict__["mask"] = mask
        __props__.__dict__["type"] = type
        return DdosBlackWhiteIp(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter
    def ip(self) -> pulumi.Output[str]:
        """
        ip list.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def mask(self) -> pulumi.Output[int]:
        """
        ip mask.
        """
        return pulumi.get(self, "mask")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        ip type, black: black ip list, white: white ip list.
        """
        return pulumi.get(self, "type")

