# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetIpStrategiesResult',
    'AwaitableGetIpStrategiesResult',
    'get_ip_strategies',
    'get_ip_strategies_output',
]

@pulumi.output_type
class GetIpStrategiesResult:
    """
    A collection of values returned by getIpStrategies.
    """
    def __init__(__self__, id=None, lists=None, result_output_file=None, service_id=None, strategy_name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if service_id and not isinstance(service_id, str):
            raise TypeError("Expected argument 'service_id' to be a str")
        pulumi.set(__self__, "service_id", service_id)
        if strategy_name and not isinstance(strategy_name, str):
            raise TypeError("Expected argument 'strategy_name' to be a str")
        pulumi.set(__self__, "strategy_name", strategy_name)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetIpStrategiesListResult']:
        """
        A list of strategy.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> str:
        """
        The service ID.
        """
        return pulumi.get(self, "service_id")

    @property
    @pulumi.getter(name="strategyName")
    def strategy_name(self) -> Optional[str]:
        """
        Name of the strategy.
        """
        return pulumi.get(self, "strategy_name")


class AwaitableGetIpStrategiesResult(GetIpStrategiesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetIpStrategiesResult(
            id=self.id,
            lists=self.lists,
            result_output_file=self.result_output_file,
            service_id=self.service_id,
            strategy_name=self.strategy_name)


def get_ip_strategies(result_output_file: Optional[str] = None,
                      service_id: Optional[str] = None,
                      strategy_name: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetIpStrategiesResult:
    """
    Use this data source to query API gateway IP strategy.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    service = tencentcloud.api_gateway.Service("service",
        service_name="ck",
        protocol="http&https",
        service_desc="your nice service",
        net_types=[
            "INNER",
            "OUTER",
        ],
        ip_version="IPv4")
    test = tencentcloud.api_gateway.IpStrategy("test",
        service_id=service.id,
        strategy_name="tf_test",
        strategy_type="BLACK",
        strategy_data="9.9.9.9")
    id = tencentcloud.ApiGateway.get_ip_strategies_output(service_id=test.service_id)
    name = tencentcloud.ApiGateway.get_ip_strategies_output(service_id=test.service_id,
        strategy_name=test.strategy_name)
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str service_id: The service ID to be queried.
    :param str strategy_name: Name of IP policy.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['serviceId'] = service_id
    __args__['strategyName'] = strategy_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:ApiGateway/getIpStrategies:getIpStrategies', __args__, opts=opts, typ=GetIpStrategiesResult).value

    return AwaitableGetIpStrategiesResult(
        id=pulumi.get(__ret__, 'id'),
        lists=pulumi.get(__ret__, 'lists'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        service_id=pulumi.get(__ret__, 'service_id'),
        strategy_name=pulumi.get(__ret__, 'strategy_name'))


@_utilities.lift_output_func(get_ip_strategies)
def get_ip_strategies_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             service_id: Optional[pulumi.Input[str]] = None,
                             strategy_name: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetIpStrategiesResult]:
    """
    Use this data source to query API gateway IP strategy.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    service = tencentcloud.api_gateway.Service("service",
        service_name="ck",
        protocol="http&https",
        service_desc="your nice service",
        net_types=[
            "INNER",
            "OUTER",
        ],
        ip_version="IPv4")
    test = tencentcloud.api_gateway.IpStrategy("test",
        service_id=service.id,
        strategy_name="tf_test",
        strategy_type="BLACK",
        strategy_data="9.9.9.9")
    id = tencentcloud.ApiGateway.get_ip_strategies_output(service_id=test.service_id)
    name = tencentcloud.ApiGateway.get_ip_strategies_output(service_id=test.service_id,
        strategy_name=test.strategy_name)
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str service_id: The service ID to be queried.
    :param str strategy_name: Name of IP policy.
    """
    ...
