# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetThrottlingServicesResult',
    'AwaitableGetThrottlingServicesResult',
    'get_throttling_services',
    'get_throttling_services_output',
]

@pulumi.output_type
class GetThrottlingServicesResult:
    """
    A collection of values returned by getThrottlingServices.
    """
    def __init__(__self__, id=None, lists=None, result_output_file=None, service_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if service_id and not isinstance(service_id, str):
            raise TypeError("Expected argument 'service_id' to be a str")
        pulumi.set(__self__, "service_id", service_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetThrottlingServicesListResult']:
        """
        A list of Throttling policy.
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="serviceId")
    def service_id(self) -> Optional[str]:
        """
        Service ID for query.
        """
        return pulumi.get(self, "service_id")


class AwaitableGetThrottlingServicesResult(GetThrottlingServicesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetThrottlingServicesResult(
            id=self.id,
            lists=self.lists,
            result_output_file=self.result_output_file,
            service_id=self.service_id)


def get_throttling_services(result_output_file: Optional[str] = None,
                            service_id: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetThrottlingServicesResult:
    """
    Use this data source to query API gateway throttling services.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    service = tencentcloud.api_gateway.Service("service",
        service_name="niceservice",
        protocol="http&https",
        service_desc="your nice service",
        net_types=[
            "INNER",
            "OUTER",
        ],
        ip_version="IPv4",
        release_limit=100,
        pre_limit=100,
        test_limit=100)
    id = tencentcloud.ApiGateway.get_throttling_services_output(service_id=service.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str service_id: Service ID for query.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    __args__['serviceId'] = service_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:ApiGateway/getThrottlingServices:getThrottlingServices', __args__, opts=opts, typ=GetThrottlingServicesResult).value

    return AwaitableGetThrottlingServicesResult(
        id=pulumi.get(__ret__, 'id'),
        lists=pulumi.get(__ret__, 'lists'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        service_id=pulumi.get(__ret__, 'service_id'))


@_utilities.lift_output_func(get_throttling_services)
def get_throttling_services_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   service_id: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetThrottlingServicesResult]:
    """
    Use this data source to query API gateway throttling services.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    service = tencentcloud.api_gateway.Service("service",
        service_name="niceservice",
        protocol="http&https",
        service_desc="your nice service",
        net_types=[
            "INNER",
            "OUTER",
        ],
        ip_version="IPv4",
        release_limit=100,
        pre_limit=100,
        test_limit=100)
    id = tencentcloud.ApiGateway.get_throttling_services_output(service_id=service.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    :param str service_id: Service ID for query.
    """
    ...
