# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetZonesByProductResult',
    'AwaitableGetZonesByProductResult',
    'get_zones_by_product',
    'get_zones_by_product_output',
]

@pulumi.output_type
class GetZonesByProductResult:
    """
    A collection of values returned by getZonesByProduct.
    """
    def __init__(__self__, id=None, include_unavailable=None, name=None, product=None, result_output_file=None, zones=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if include_unavailable and not isinstance(include_unavailable, bool):
            raise TypeError("Expected argument 'include_unavailable' to be a bool")
        pulumi.set(__self__, "include_unavailable", include_unavailable)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if product and not isinstance(product, str):
            raise TypeError("Expected argument 'product' to be a str")
        pulumi.set(__self__, "product", product)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if zones and not isinstance(zones, list):
            raise TypeError("Expected argument 'zones' to be a list")
        pulumi.set(__self__, "zones", zones)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="includeUnavailable")
    def include_unavailable(self) -> Optional[bool]:
        return pulumi.get(self, "include_unavailable")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        The name of the zone, like `ap-guangzhou-3`.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def product(self) -> str:
        return pulumi.get(self, "product")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def zones(self) -> Sequence['outputs.GetZonesByProductZoneResult']:
        """
        A list of zones will be exported and its every element contains the following attributes:
        """
        return pulumi.get(self, "zones")


class AwaitableGetZonesByProductResult(GetZonesByProductResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZonesByProductResult(
            id=self.id,
            include_unavailable=self.include_unavailable,
            name=self.name,
            product=self.product,
            result_output_file=self.result_output_file,
            zones=self.zones)


def get_zones_by_product(include_unavailable: Optional[bool] = None,
                         name: Optional[str] = None,
                         product: Optional[str] = None,
                         result_output_file: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZonesByProductResult:
    """
    Use this data source to get the available zones in current region. Must set product param to fetch the product infomations(e.g. => cvm, vpc). By default only `AVAILABLE` zones will be returned, but `UNAVAILABLE` zones can also be fetched when `include_unavailable` is specified.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    all = tencentcloud.Availability.get_zones_by_product(product="cvm")
    ```
    <!--End PulumiCodeChooser -->


    :param bool include_unavailable: A bool variable indicates that the query will include `UNAVAILABLE` zones.
    :param str name: When specified, only the zone with the exactly name match will be returned.
    :param str product: A string variable indicates that the query will use product information.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['includeUnavailable'] = include_unavailable
    __args__['name'] = name
    __args__['product'] = product
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Availability/getZonesByProduct:getZonesByProduct', __args__, opts=opts, typ=GetZonesByProductResult).value

    return AwaitableGetZonesByProductResult(
        id=pulumi.get(__ret__, 'id'),
        include_unavailable=pulumi.get(__ret__, 'include_unavailable'),
        name=pulumi.get(__ret__, 'name'),
        product=pulumi.get(__ret__, 'product'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        zones=pulumi.get(__ret__, 'zones'))


@_utilities.lift_output_func(get_zones_by_product)
def get_zones_by_product_output(include_unavailable: Optional[pulumi.Input[Optional[bool]]] = None,
                                name: Optional[pulumi.Input[Optional[str]]] = None,
                                product: Optional[pulumi.Input[str]] = None,
                                result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetZonesByProductResult]:
    """
    Use this data source to get the available zones in current region. Must set product param to fetch the product infomations(e.g. => cvm, vpc). By default only `AVAILABLE` zones will be returned, but `UNAVAILABLE` zones can also be fetched when `include_unavailable` is specified.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    all = tencentcloud.Availability.get_zones_by_product(product="cvm")
    ```
    <!--End PulumiCodeChooser -->


    :param bool include_unavailable: A bool variable indicates that the query will include `UNAVAILABLE` zones.
    :param str name: When specified, only the zone with the exactly name match will be returned.
    :param str product: A string variable indicates that the query will use product information.
    :param str result_output_file: Used to save results.
    """
    ...
