# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['UrlPurgeArgs', 'UrlPurge']

@pulumi.input_type
class UrlPurgeArgs:
    def __init__(__self__, *,
                 urls: pulumi.Input[Sequence[pulumi.Input[str]]],
                 area: Optional[pulumi.Input[str]] = None,
                 redo: Optional[pulumi.Input[int]] = None,
                 url_encode: Optional[pulumi.Input[bool]] = None):
        """
        The set of arguments for constructing a UrlPurge resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        :param pulumi.Input[str] area: Specify purge area. NOTE: only purge same area cache contents.
        :param pulumi.Input[int] redo: Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        :param pulumi.Input[bool] url_encode: Whether to encode urls, if set to `true` will auto encode instead of manual process.
        """
        pulumi.set(__self__, "urls", urls)
        if area is not None:
            pulumi.set(__self__, "area", area)
        if redo is not None:
            pulumi.set(__self__, "redo", redo)
        if url_encode is not None:
            pulumi.set(__self__, "url_encode", url_encode)

    @property
    @pulumi.getter
    def urls(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        return pulumi.get(self, "urls")

    @urls.setter
    def urls(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "urls", value)

    @property
    @pulumi.getter
    def area(self) -> Optional[pulumi.Input[str]]:
        """
        Specify purge area. NOTE: only purge same area cache contents.
        """
        return pulumi.get(self, "area")

    @area.setter
    def area(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "area", value)

    @property
    @pulumi.getter
    def redo(self) -> Optional[pulumi.Input[int]]:
        """
        Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        """
        return pulumi.get(self, "redo")

    @redo.setter
    def redo(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "redo", value)

    @property
    @pulumi.getter(name="urlEncode")
    def url_encode(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to encode urls, if set to `true` will auto encode instead of manual process.
        """
        return pulumi.get(self, "url_encode")

    @url_encode.setter
    def url_encode(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "url_encode", value)


@pulumi.input_type
class _UrlPurgeState:
    def __init__(__self__, *,
                 area: Optional[pulumi.Input[str]] = None,
                 purge_histories: Optional[pulumi.Input[Sequence[pulumi.Input['UrlPurgePurgeHistoryArgs']]]] = None,
                 redo: Optional[pulumi.Input[int]] = None,
                 task_id: Optional[pulumi.Input[str]] = None,
                 url_encode: Optional[pulumi.Input[bool]] = None,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering UrlPurge resources.
        :param pulumi.Input[str] area: Specify purge area. NOTE: only purge same area cache contents.
        :param pulumi.Input[Sequence[pulumi.Input['UrlPurgePurgeHistoryArgs']]] purge_histories: logs of latest purge task.
        :param pulumi.Input[int] redo: Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        :param pulumi.Input[str] task_id: Task id of last operation.
        :param pulumi.Input[bool] url_encode: Whether to encode urls, if set to `true` will auto encode instead of manual process.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        if area is not None:
            pulumi.set(__self__, "area", area)
        if purge_histories is not None:
            pulumi.set(__self__, "purge_histories", purge_histories)
        if redo is not None:
            pulumi.set(__self__, "redo", redo)
        if task_id is not None:
            pulumi.set(__self__, "task_id", task_id)
        if url_encode is not None:
            pulumi.set(__self__, "url_encode", url_encode)
        if urls is not None:
            pulumi.set(__self__, "urls", urls)

    @property
    @pulumi.getter
    def area(self) -> Optional[pulumi.Input[str]]:
        """
        Specify purge area. NOTE: only purge same area cache contents.
        """
        return pulumi.get(self, "area")

    @area.setter
    def area(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "area", value)

    @property
    @pulumi.getter(name="purgeHistories")
    def purge_histories(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['UrlPurgePurgeHistoryArgs']]]]:
        """
        logs of latest purge task.
        """
        return pulumi.get(self, "purge_histories")

    @purge_histories.setter
    def purge_histories(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['UrlPurgePurgeHistoryArgs']]]]):
        pulumi.set(self, "purge_histories", value)

    @property
    @pulumi.getter
    def redo(self) -> Optional[pulumi.Input[int]]:
        """
        Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        """
        return pulumi.get(self, "redo")

    @redo.setter
    def redo(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "redo", value)

    @property
    @pulumi.getter(name="taskId")
    def task_id(self) -> Optional[pulumi.Input[str]]:
        """
        Task id of last operation.
        """
        return pulumi.get(self, "task_id")

    @task_id.setter
    def task_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "task_id", value)

    @property
    @pulumi.getter(name="urlEncode")
    def url_encode(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether to encode urls, if set to `true` will auto encode instead of manual process.
        """
        return pulumi.get(self, "url_encode")

    @url_encode.setter
    def url_encode(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "url_encode", value)

    @property
    @pulumi.getter
    def urls(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        return pulumi.get(self, "urls")

    @urls.setter
    def urls(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "urls", value)


class UrlPurge(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 area: Optional[pulumi.Input[str]] = None,
                 redo: Optional[pulumi.Input[int]] = None,
                 url_encode: Optional[pulumi.Input[bool]] = None,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provide a resource to invoke a Url Purge Request.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cdn.UrlPurge("foo", urls=["https://www.example.com/a"])
        ```
        <!--End PulumiCodeChooser -->

        ### argument to request new purge task with same urls

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cdn.UrlPurge("foo",
            redo=1,
            urls=["https://www.example.com/a"])
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] area: Specify purge area. NOTE: only purge same area cache contents.
        :param pulumi.Input[int] redo: Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        :param pulumi.Input[bool] url_encode: Whether to encode urls, if set to `true` will auto encode instead of manual process.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: UrlPurgeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provide a resource to invoke a Url Purge Request.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cdn.UrlPurge("foo", urls=["https://www.example.com/a"])
        ```
        <!--End PulumiCodeChooser -->

        ### argument to request new purge task with same urls

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.cdn.UrlPurge("foo",
            redo=1,
            urls=["https://www.example.com/a"])
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param UrlPurgeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UrlPurgeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 area: Optional[pulumi.Input[str]] = None,
                 redo: Optional[pulumi.Input[int]] = None,
                 url_encode: Optional[pulumi.Input[bool]] = None,
                 urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UrlPurgeArgs.__new__(UrlPurgeArgs)

            __props__.__dict__["area"] = area
            __props__.__dict__["redo"] = redo
            __props__.__dict__["url_encode"] = url_encode
            if urls is None and not opts.urn:
                raise TypeError("Missing required property 'urls'")
            __props__.__dict__["urls"] = urls
            __props__.__dict__["purge_histories"] = None
            __props__.__dict__["task_id"] = None
        super(UrlPurge, __self__).__init__(
            'tencentcloud:Cdn/urlPurge:UrlPurge',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            area: Optional[pulumi.Input[str]] = None,
            purge_histories: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['UrlPurgePurgeHistoryArgs']]]]] = None,
            redo: Optional[pulumi.Input[int]] = None,
            task_id: Optional[pulumi.Input[str]] = None,
            url_encode: Optional[pulumi.Input[bool]] = None,
            urls: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'UrlPurge':
        """
        Get an existing UrlPurge resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] area: Specify purge area. NOTE: only purge same area cache contents.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['UrlPurgePurgeHistoryArgs']]]] purge_histories: logs of latest purge task.
        :param pulumi.Input[int] redo: Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        :param pulumi.Input[str] task_id: Task id of last operation.
        :param pulumi.Input[bool] url_encode: Whether to encode urls, if set to `true` will auto encode instead of manual process.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] urls: List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UrlPurgeState.__new__(_UrlPurgeState)

        __props__.__dict__["area"] = area
        __props__.__dict__["purge_histories"] = purge_histories
        __props__.__dict__["redo"] = redo
        __props__.__dict__["task_id"] = task_id
        __props__.__dict__["url_encode"] = url_encode
        __props__.__dict__["urls"] = urls
        return UrlPurge(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def area(self) -> pulumi.Output[Optional[str]]:
        """
        Specify purge area. NOTE: only purge same area cache contents.
        """
        return pulumi.get(self, "area")

    @property
    @pulumi.getter(name="purgeHistories")
    def purge_histories(self) -> pulumi.Output[Sequence['outputs.UrlPurgePurgeHistory']]:
        """
        logs of latest purge task.
        """
        return pulumi.get(self, "purge_histories")

    @property
    @pulumi.getter
    def redo(self) -> pulumi.Output[Optional[int]]:
        """
        Change to purge again. NOTE: this argument only works while resource update, if set to `0` or null will not be triggered.
        """
        return pulumi.get(self, "redo")

    @property
    @pulumi.getter(name="taskId")
    def task_id(self) -> pulumi.Output[str]:
        """
        Task id of last operation.
        """
        return pulumi.get(self, "task_id")

    @property
    @pulumi.getter(name="urlEncode")
    def url_encode(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether to encode urls, if set to `true` will auto encode instead of manual process.
        """
        return pulumi.get(self, "url_encode")

    @property
    @pulumi.getter
    def urls(self) -> pulumi.Output[Sequence[str]]:
        """
        List of url to purge. NOTE: urls need include protocol prefix `http://` or `https://`.
        """
        return pulumi.get(self, "urls")

