# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['VpcFirewallSwitchArgs', 'VpcFirewallSwitch']

@pulumi.input_type
class VpcFirewallSwitchArgs:
    def __init__(__self__, *,
                 enable: pulumi.Input[int],
                 switch_id: pulumi.Input[str],
                 vpc_ins_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a VpcFirewallSwitch resource.
        :param pulumi.Input[int] enable: Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        :param pulumi.Input[str] switch_id: Firewall switch ID.
        :param pulumi.Input[str] vpc_ins_id: Firewall instance id.
        """
        pulumi.set(__self__, "enable", enable)
        pulumi.set(__self__, "switch_id", switch_id)
        pulumi.set(__self__, "vpc_ins_id", vpc_ins_id)

    @property
    @pulumi.getter
    def enable(self) -> pulumi.Input[int]:
        """
        Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: pulumi.Input[int]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter(name="switchId")
    def switch_id(self) -> pulumi.Input[str]:
        """
        Firewall switch ID.
        """
        return pulumi.get(self, "switch_id")

    @switch_id.setter
    def switch_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "switch_id", value)

    @property
    @pulumi.getter(name="vpcInsId")
    def vpc_ins_id(self) -> pulumi.Input[str]:
        """
        Firewall instance id.
        """
        return pulumi.get(self, "vpc_ins_id")

    @vpc_ins_id.setter
    def vpc_ins_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "vpc_ins_id", value)


@pulumi.input_type
class _VpcFirewallSwitchState:
    def __init__(__self__, *,
                 enable: Optional[pulumi.Input[int]] = None,
                 switch_id: Optional[pulumi.Input[str]] = None,
                 vpc_ins_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VpcFirewallSwitch resources.
        :param pulumi.Input[int] enable: Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        :param pulumi.Input[str] switch_id: Firewall switch ID.
        :param pulumi.Input[str] vpc_ins_id: Firewall instance id.
        """
        if enable is not None:
            pulumi.set(__self__, "enable", enable)
        if switch_id is not None:
            pulumi.set(__self__, "switch_id", switch_id)
        if vpc_ins_id is not None:
            pulumi.set(__self__, "vpc_ins_id", vpc_ins_id)

    @property
    @pulumi.getter
    def enable(self) -> Optional[pulumi.Input[int]]:
        """
        Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        """
        return pulumi.get(self, "enable")

    @enable.setter
    def enable(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "enable", value)

    @property
    @pulumi.getter(name="switchId")
    def switch_id(self) -> Optional[pulumi.Input[str]]:
        """
        Firewall switch ID.
        """
        return pulumi.get(self, "switch_id")

    @switch_id.setter
    def switch_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "switch_id", value)

    @property
    @pulumi.getter(name="vpcInsId")
    def vpc_ins_id(self) -> Optional[pulumi.Input[str]]:
        """
        Firewall instance id.
        """
        return pulumi.get(self, "vpc_ins_id")

    @vpc_ins_id.setter
    def vpc_ins_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vpc_ins_id", value)


class VpcFirewallSwitch(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 switch_id: Optional[pulumi.Input[str]] = None,
                 vpc_ins_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a cfw vpc_firewall_switch

        ## Example Usage

        ### Turn off switch

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        example_vpc_fw_switches = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
        example_vpc_firewall_switch = tencentcloud.cfw.VpcFirewallSwitch("exampleVpcFirewallSwitch",
            vpc_ins_id=example_vpc_fw_switches.id,
            switch_id=example_vpc_fw_switches.switch_lists[0].switch_id,
            enable=0)
        ```
        <!--End PulumiCodeChooser -->

        ### Or turn on switch

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        example_vpc_fw_switches = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
        example_vpc_firewall_switch = tencentcloud.cfw.VpcFirewallSwitch("exampleVpcFirewallSwitch",
            vpc_ins_id=example_vpc_fw_switches.id,
            switch_id=example_vpc_fw_switches.switch_lists[0].switch_id,
            enable=1)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        cfw vpc_firewall_switch can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Cfw/vpcFirewallSwitch:VpcFirewallSwitch example cfwg-c8c2de41#cfws-f2c63ded84
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] enable: Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        :param pulumi.Input[str] switch_id: Firewall switch ID.
        :param pulumi.Input[str] vpc_ins_id: Firewall instance id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VpcFirewallSwitchArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a cfw vpc_firewall_switch

        ## Example Usage

        ### Turn off switch

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        example_vpc_fw_switches = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
        example_vpc_firewall_switch = tencentcloud.cfw.VpcFirewallSwitch("exampleVpcFirewallSwitch",
            vpc_ins_id=example_vpc_fw_switches.id,
            switch_id=example_vpc_fw_switches.switch_lists[0].switch_id,
            enable=0)
        ```
        <!--End PulumiCodeChooser -->

        ### Or turn on switch

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        example_vpc_fw_switches = tencentcloud.Cfw.get_vpc_fw_switches(vpc_ins_id="cfwg-c8c2de41")
        example_vpc_firewall_switch = tencentcloud.cfw.VpcFirewallSwitch("exampleVpcFirewallSwitch",
            vpc_ins_id=example_vpc_fw_switches.id,
            switch_id=example_vpc_fw_switches.switch_lists[0].switch_id,
            enable=1)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        cfw vpc_firewall_switch can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Cfw/vpcFirewallSwitch:VpcFirewallSwitch example cfwg-c8c2de41#cfws-f2c63ded84
        ```

        :param str resource_name: The name of the resource.
        :param VpcFirewallSwitchArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VpcFirewallSwitchArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 enable: Optional[pulumi.Input[int]] = None,
                 switch_id: Optional[pulumi.Input[str]] = None,
                 vpc_ins_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VpcFirewallSwitchArgs.__new__(VpcFirewallSwitchArgs)

            if enable is None and not opts.urn:
                raise TypeError("Missing required property 'enable'")
            __props__.__dict__["enable"] = enable
            if switch_id is None and not opts.urn:
                raise TypeError("Missing required property 'switch_id'")
            __props__.__dict__["switch_id"] = switch_id
            if vpc_ins_id is None and not opts.urn:
                raise TypeError("Missing required property 'vpc_ins_id'")
            __props__.__dict__["vpc_ins_id"] = vpc_ins_id
        super(VpcFirewallSwitch, __self__).__init__(
            'tencentcloud:Cfw/vpcFirewallSwitch:VpcFirewallSwitch',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            enable: Optional[pulumi.Input[int]] = None,
            switch_id: Optional[pulumi.Input[str]] = None,
            vpc_ins_id: Optional[pulumi.Input[str]] = None) -> 'VpcFirewallSwitch':
        """
        Get an existing VpcFirewallSwitch resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] enable: Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        :param pulumi.Input[str] switch_id: Firewall switch ID.
        :param pulumi.Input[str] vpc_ins_id: Firewall instance id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VpcFirewallSwitchState.__new__(_VpcFirewallSwitchState)

        __props__.__dict__["enable"] = enable
        __props__.__dict__["switch_id"] = switch_id
        __props__.__dict__["vpc_ins_id"] = vpc_ins_id
        return VpcFirewallSwitch(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def enable(self) -> pulumi.Output[int]:
        """
        Turn the switch on or off. 0: turn off the switch; 1: Turn on the switch.
        """
        return pulumi.get(self, "enable")

    @property
    @pulumi.getter(name="switchId")
    def switch_id(self) -> pulumi.Output[str]:
        """
        Firewall switch ID.
        """
        return pulumi.get(self, "switch_id")

    @property
    @pulumi.getter(name="vpcInsId")
    def vpc_ins_id(self) -> pulumi.Output[str]:
        """
        Firewall instance id.
        """
        return pulumi.get(self, "vpc_ins_id")

