# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AccessRuleArgs', 'AccessRule']

@pulumi.input_type
class AccessRuleArgs:
    def __init__(__self__, *,
                 access_group_id: pulumi.Input[str],
                 access_rule: pulumi.Input['AccessRuleAccessRuleArgs']):
        """
        The set of arguments for constructing a AccessRule resource.
        :param pulumi.Input[str] access_group_id: access group id.
        :param pulumi.Input['AccessRuleAccessRuleArgs'] access_rule: rule detail.
        """
        pulumi.set(__self__, "access_group_id", access_group_id)
        pulumi.set(__self__, "access_rule", access_rule)

    @property
    @pulumi.getter(name="accessGroupId")
    def access_group_id(self) -> pulumi.Input[str]:
        """
        access group id.
        """
        return pulumi.get(self, "access_group_id")

    @access_group_id.setter
    def access_group_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "access_group_id", value)

    @property
    @pulumi.getter(name="accessRule")
    def access_rule(self) -> pulumi.Input['AccessRuleAccessRuleArgs']:
        """
        rule detail.
        """
        return pulumi.get(self, "access_rule")

    @access_rule.setter
    def access_rule(self, value: pulumi.Input['AccessRuleAccessRuleArgs']):
        pulumi.set(self, "access_rule", value)


@pulumi.input_type
class _AccessRuleState:
    def __init__(__self__, *,
                 access_group_id: Optional[pulumi.Input[str]] = None,
                 access_rule: Optional[pulumi.Input['AccessRuleAccessRuleArgs']] = None):
        """
        Input properties used for looking up and filtering AccessRule resources.
        :param pulumi.Input[str] access_group_id: access group id.
        :param pulumi.Input['AccessRuleAccessRuleArgs'] access_rule: rule detail.
        """
        if access_group_id is not None:
            pulumi.set(__self__, "access_group_id", access_group_id)
        if access_rule is not None:
            pulumi.set(__self__, "access_rule", access_rule)

    @property
    @pulumi.getter(name="accessGroupId")
    def access_group_id(self) -> Optional[pulumi.Input[str]]:
        """
        access group id.
        """
        return pulumi.get(self, "access_group_id")

    @access_group_id.setter
    def access_group_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "access_group_id", value)

    @property
    @pulumi.getter(name="accessRule")
    def access_rule(self) -> Optional[pulumi.Input['AccessRuleAccessRuleArgs']]:
        """
        rule detail.
        """
        return pulumi.get(self, "access_rule")

    @access_rule.setter
    def access_rule(self, value: Optional[pulumi.Input['AccessRuleAccessRuleArgs']]):
        pulumi.set(self, "access_rule", value)


class AccessRule(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_group_id: Optional[pulumi.Input[str]] = None,
                 access_rule: Optional[pulumi.Input[pulumi.InputType['AccessRuleAccessRuleArgs']]] = None,
                 __props__=None):
        """
        Provides a resource to create a chdfs access_rule

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        access_rule = tencentcloud.chdfs.AccessRule("accessRule",
            access_group_id="ag-bvmzrbsm",
            access_rule=tencentcloud.chdfs.AccessRuleAccessRuleArgs(
                access_mode=2,
                address="10.0.1.1",
                priority=12,
            ))
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        chdfs access_rule can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Chdfs/accessRule:AccessRule access_rule access_group_id#access_rule_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_group_id: access group id.
        :param pulumi.Input[pulumi.InputType['AccessRuleAccessRuleArgs']] access_rule: rule detail.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AccessRuleArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a chdfs access_rule

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        access_rule = tencentcloud.chdfs.AccessRule("accessRule",
            access_group_id="ag-bvmzrbsm",
            access_rule=tencentcloud.chdfs.AccessRuleAccessRuleArgs(
                access_mode=2,
                address="10.0.1.1",
                priority=12,
            ))
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        chdfs access_rule can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Chdfs/accessRule:AccessRule access_rule access_group_id#access_rule_id
        ```

        :param str resource_name: The name of the resource.
        :param AccessRuleArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccessRuleArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 access_group_id: Optional[pulumi.Input[str]] = None,
                 access_rule: Optional[pulumi.Input[pulumi.InputType['AccessRuleAccessRuleArgs']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccessRuleArgs.__new__(AccessRuleArgs)

            if access_group_id is None and not opts.urn:
                raise TypeError("Missing required property 'access_group_id'")
            __props__.__dict__["access_group_id"] = access_group_id
            if access_rule is None and not opts.urn:
                raise TypeError("Missing required property 'access_rule'")
            __props__.__dict__["access_rule"] = access_rule
        super(AccessRule, __self__).__init__(
            'tencentcloud:Chdfs/accessRule:AccessRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            access_group_id: Optional[pulumi.Input[str]] = None,
            access_rule: Optional[pulumi.Input[pulumi.InputType['AccessRuleAccessRuleArgs']]] = None) -> 'AccessRule':
        """
        Get an existing AccessRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] access_group_id: access group id.
        :param pulumi.Input[pulumi.InputType['AccessRuleAccessRuleArgs']] access_rule: rule detail.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccessRuleState.__new__(_AccessRuleState)

        __props__.__dict__["access_group_id"] = access_group_id
        __props__.__dict__["access_rule"] = access_rule
        return AccessRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="accessGroupId")
    def access_group_id(self) -> pulumi.Output[str]:
        """
        access group id.
        """
        return pulumi.get(self, "access_group_id")

    @property
    @pulumi.getter(name="accessRule")
    def access_rule(self) -> pulumi.Output['outputs.AccessRuleAccessRule']:
        """
        rule detail.
        """
        return pulumi.get(self, "access_rule")

