# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AttachmentArgs', 'Attachment']

@pulumi.input_type
class AttachmentArgs:
    def __init__(__self__, *,
                 clb_id: pulumi.Input[str],
                 listener_id: pulumi.Input[str],
                 targets: pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]],
                 rule_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Attachment resource.
        :param pulumi.Input[str] clb_id: ID of the CLB.
        :param pulumi.Input[str] listener_id: ID of the CLB listener.
        :param pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]] targets: Information of the backends to be attached.
        :param pulumi.Input[str] rule_id: ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        """
        pulumi.set(__self__, "clb_id", clb_id)
        pulumi.set(__self__, "listener_id", listener_id)
        pulumi.set(__self__, "targets", targets)
        if rule_id is not None:
            pulumi.set(__self__, "rule_id", rule_id)

    @property
    @pulumi.getter(name="clbId")
    def clb_id(self) -> pulumi.Input[str]:
        """
        ID of the CLB.
        """
        return pulumi.get(self, "clb_id")

    @clb_id.setter
    def clb_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "clb_id", value)

    @property
    @pulumi.getter(name="listenerId")
    def listener_id(self) -> pulumi.Input[str]:
        """
        ID of the CLB listener.
        """
        return pulumi.get(self, "listener_id")

    @listener_id.setter
    def listener_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "listener_id", value)

    @property
    @pulumi.getter
    def targets(self) -> pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]]:
        """
        Information of the backends to be attached.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]]):
        pulumi.set(self, "targets", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_id", value)


@pulumi.input_type
class _AttachmentState:
    def __init__(__self__, *,
                 clb_id: Optional[pulumi.Input[str]] = None,
                 listener_id: Optional[pulumi.Input[str]] = None,
                 protocol_type: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 targets: Optional[pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]]] = None):
        """
        Input properties used for looking up and filtering Attachment resources.
        :param pulumi.Input[str] clb_id: ID of the CLB.
        :param pulumi.Input[str] listener_id: ID of the CLB listener.
        :param pulumi.Input[str] protocol_type: Type of protocol within the listener.
        :param pulumi.Input[str] rule_id: ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        :param pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]] targets: Information of the backends to be attached.
        """
        if clb_id is not None:
            pulumi.set(__self__, "clb_id", clb_id)
        if listener_id is not None:
            pulumi.set(__self__, "listener_id", listener_id)
        if protocol_type is not None:
            pulumi.set(__self__, "protocol_type", protocol_type)
        if rule_id is not None:
            pulumi.set(__self__, "rule_id", rule_id)
        if targets is not None:
            pulumi.set(__self__, "targets", targets)

    @property
    @pulumi.getter(name="clbId")
    def clb_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the CLB.
        """
        return pulumi.get(self, "clb_id")

    @clb_id.setter
    def clb_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "clb_id", value)

    @property
    @pulumi.getter(name="listenerId")
    def listener_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the CLB listener.
        """
        return pulumi.get(self, "listener_id")

    @listener_id.setter
    def listener_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "listener_id", value)

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> Optional[pulumi.Input[str]]:
        """
        Type of protocol within the listener.
        """
        return pulumi.get(self, "protocol_type")

    @protocol_type.setter
    def protocol_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol_type", value)

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        """
        return pulumi.get(self, "rule_id")

    @rule_id.setter
    def rule_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rule_id", value)

    @property
    @pulumi.getter
    def targets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]]]:
        """
        Information of the backends to be attached.
        """
        return pulumi.get(self, "targets")

    @targets.setter
    def targets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AttachmentTargetArgs']]]]):
        pulumi.set(self, "targets", value)


class Attachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 clb_id: Optional[pulumi.Input[str]] = None,
                 listener_id: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 targets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachmentTargetArgs']]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a CLB attachment.

        > **NOTE:** This resource is designed to manage the entire set of binding relationships associated with a particular CLB (Cloud Load Balancer). As such, it does not allow the simultaneous use of this resource for the same CLB across different contexts or environments.

        ## Example Usage

        ### Bind a Cvm instance

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[tencentcloud.clb.AttachmentTargetArgs(
                instance_id="ins-1flbqyp8",
                port=80,
                weight=10,
            )])
        ```
        <!--End PulumiCodeChooser -->

        ### Bind multiple Cvm instances

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[
                tencentcloud.clb.AttachmentTargetArgs(
                    instance_id="ins-1flbqyp8",
                    port=80,
                    weight=10,
                ),
                tencentcloud.clb.AttachmentTargetArgs(
                    instance_id="ins-ekloqpa1",
                    port=81,
                    weight=10,
                ),
            ])
        ```
        <!--End PulumiCodeChooser -->

        ### Bind backend target is ENI

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[tencentcloud.clb.AttachmentTargetArgs(
                eni_ip="example-ip",
                port=23,
                weight=50,
            )])
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        CLB attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Clb/attachment:Attachment foo loc-4xxr2cy7#lbl-hh141sn9#lb-7a0t6zqb
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] clb_id: ID of the CLB.
        :param pulumi.Input[str] listener_id: ID of the CLB listener.
        :param pulumi.Input[str] rule_id: ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachmentTargetArgs']]]] targets: Information of the backends to be attached.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a CLB attachment.

        > **NOTE:** This resource is designed to manage the entire set of binding relationships associated with a particular CLB (Cloud Load Balancer). As such, it does not allow the simultaneous use of this resource for the same CLB across different contexts or environments.

        ## Example Usage

        ### Bind a Cvm instance

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[tencentcloud.clb.AttachmentTargetArgs(
                instance_id="ins-1flbqyp8",
                port=80,
                weight=10,
            )])
        ```
        <!--End PulumiCodeChooser -->

        ### Bind multiple Cvm instances

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[
                tencentcloud.clb.AttachmentTargetArgs(
                    instance_id="ins-1flbqyp8",
                    port=80,
                    weight=10,
                ),
                tencentcloud.clb.AttachmentTargetArgs(
                    instance_id="ins-ekloqpa1",
                    port=81,
                    weight=10,
                ),
            ])
        ```
        <!--End PulumiCodeChooser -->

        ### Bind backend target is ENI

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.clb.Attachment("foo",
            clb_id="lb-k2zjp9lv",
            listener_id="lbl-hh141sn9",
            rule_id="loc-4xxr2cy7",
            targets=[tencentcloud.clb.AttachmentTargetArgs(
                eni_ip="example-ip",
                port=23,
                weight=50,
            )])
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        CLB attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Clb/attachment:Attachment foo loc-4xxr2cy7#lbl-hh141sn9#lb-7a0t6zqb
        ```

        :param str resource_name: The name of the resource.
        :param AttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 clb_id: Optional[pulumi.Input[str]] = None,
                 listener_id: Optional[pulumi.Input[str]] = None,
                 rule_id: Optional[pulumi.Input[str]] = None,
                 targets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachmentTargetArgs']]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AttachmentArgs.__new__(AttachmentArgs)

            if clb_id is None and not opts.urn:
                raise TypeError("Missing required property 'clb_id'")
            __props__.__dict__["clb_id"] = clb_id
            if listener_id is None and not opts.urn:
                raise TypeError("Missing required property 'listener_id'")
            __props__.__dict__["listener_id"] = listener_id
            __props__.__dict__["rule_id"] = rule_id
            if targets is None and not opts.urn:
                raise TypeError("Missing required property 'targets'")
            __props__.__dict__["targets"] = targets
            __props__.__dict__["protocol_type"] = None
        super(Attachment, __self__).__init__(
            'tencentcloud:Clb/attachment:Attachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            clb_id: Optional[pulumi.Input[str]] = None,
            listener_id: Optional[pulumi.Input[str]] = None,
            protocol_type: Optional[pulumi.Input[str]] = None,
            rule_id: Optional[pulumi.Input[str]] = None,
            targets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachmentTargetArgs']]]]] = None) -> 'Attachment':
        """
        Get an existing Attachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] clb_id: ID of the CLB.
        :param pulumi.Input[str] listener_id: ID of the CLB listener.
        :param pulumi.Input[str] protocol_type: Type of protocol within the listener.
        :param pulumi.Input[str] rule_id: ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AttachmentTargetArgs']]]] targets: Information of the backends to be attached.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AttachmentState.__new__(_AttachmentState)

        __props__.__dict__["clb_id"] = clb_id
        __props__.__dict__["listener_id"] = listener_id
        __props__.__dict__["protocol_type"] = protocol_type
        __props__.__dict__["rule_id"] = rule_id
        __props__.__dict__["targets"] = targets
        return Attachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="clbId")
    def clb_id(self) -> pulumi.Output[str]:
        """
        ID of the CLB.
        """
        return pulumi.get(self, "clb_id")

    @property
    @pulumi.getter(name="listenerId")
    def listener_id(self) -> pulumi.Output[str]:
        """
        ID of the CLB listener.
        """
        return pulumi.get(self, "listener_id")

    @property
    @pulumi.getter(name="protocolType")
    def protocol_type(self) -> pulumi.Output[str]:
        """
        Type of protocol within the listener.
        """
        return pulumi.get(self, "protocol_type")

    @property
    @pulumi.getter(name="ruleId")
    def rule_id(self) -> pulumi.Output[Optional[str]]:
        """
        ID of the CLB listener rule. Only supports listeners of `HTTPS` and `HTTP` protocol.
        """
        return pulumi.get(self, "rule_id")

    @property
    @pulumi.getter
    def targets(self) -> pulumi.Output[Sequence['outputs.AttachmentTarget']]:
        """
        Information of the backends to be attached.
        """
        return pulumi.get(self, "targets")

