# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BackupStreamArgs', 'BackupStream']

@pulumi.input_type
class BackupStreamArgs:
    def __init__(__self__, *,
                 app_name: pulumi.Input[str],
                 push_domain_name: pulumi.Input[str],
                 stream_name: pulumi.Input[str],
                 upstream_sequence: pulumi.Input[str]):
        """
        The set of arguments for constructing a BackupStream resource.
        :param pulumi.Input[str] app_name: App name.
        :param pulumi.Input[str] push_domain_name: Push domain.
        :param pulumi.Input[str] stream_name: Stream id.
        :param pulumi.Input[str] upstream_sequence: Sequence.
        """
        pulumi.set(__self__, "app_name", app_name)
        pulumi.set(__self__, "push_domain_name", push_domain_name)
        pulumi.set(__self__, "stream_name", stream_name)
        pulumi.set(__self__, "upstream_sequence", upstream_sequence)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> pulumi.Input[str]:
        """
        App name.
        """
        return pulumi.get(self, "app_name")

    @app_name.setter
    def app_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "app_name", value)

    @property
    @pulumi.getter(name="pushDomainName")
    def push_domain_name(self) -> pulumi.Input[str]:
        """
        Push domain.
        """
        return pulumi.get(self, "push_domain_name")

    @push_domain_name.setter
    def push_domain_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "push_domain_name", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Input[str]:
        """
        Stream id.
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="upstreamSequence")
    def upstream_sequence(self) -> pulumi.Input[str]:
        """
        Sequence.
        """
        return pulumi.get(self, "upstream_sequence")

    @upstream_sequence.setter
    def upstream_sequence(self, value: pulumi.Input[str]):
        pulumi.set(self, "upstream_sequence", value)


@pulumi.input_type
class _BackupStreamState:
    def __init__(__self__, *,
                 app_name: Optional[pulumi.Input[str]] = None,
                 push_domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 upstream_sequence: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering BackupStream resources.
        :param pulumi.Input[str] app_name: App name.
        :param pulumi.Input[str] push_domain_name: Push domain.
        :param pulumi.Input[str] stream_name: Stream id.
        :param pulumi.Input[str] upstream_sequence: Sequence.
        """
        if app_name is not None:
            pulumi.set(__self__, "app_name", app_name)
        if push_domain_name is not None:
            pulumi.set(__self__, "push_domain_name", push_domain_name)
        if stream_name is not None:
            pulumi.set(__self__, "stream_name", stream_name)
        if upstream_sequence is not None:
            pulumi.set(__self__, "upstream_sequence", upstream_sequence)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> Optional[pulumi.Input[str]]:
        """
        App name.
        """
        return pulumi.get(self, "app_name")

    @app_name.setter
    def app_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "app_name", value)

    @property
    @pulumi.getter(name="pushDomainName")
    def push_domain_name(self) -> Optional[pulumi.Input[str]]:
        """
        Push domain.
        """
        return pulumi.get(self, "push_domain_name")

    @push_domain_name.setter
    def push_domain_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "push_domain_name", value)

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> Optional[pulumi.Input[str]]:
        """
        Stream id.
        """
        return pulumi.get(self, "stream_name")

    @stream_name.setter
    def stream_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "stream_name", value)

    @property
    @pulumi.getter(name="upstreamSequence")
    def upstream_sequence(self) -> Optional[pulumi.Input[str]]:
        """
        Sequence.
        """
        return pulumi.get(self, "upstream_sequence")

    @upstream_sequence.setter
    def upstream_sequence(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "upstream_sequence", value)


class BackupStream(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_name: Optional[pulumi.Input[str]] = None,
                 push_domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 upstream_sequence: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a css backup_stream

        > **NOTE:** This resource is only valid when the push stream. When the push stream ends, it will be deleted.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        backup_stream = tencentcloud.css.BackupStream("backupStream",
            app_name="live",
            push_domain_name="177154.push.tlivecloud.com",
            stream_name="1308919341_test",
            upstream_sequence="2209501773993286139")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        css backup_stream can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Css/backupStream:BackupStream backup_stream pushDomainName#appName#streamName
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_name: App name.
        :param pulumi.Input[str] push_domain_name: Push domain.
        :param pulumi.Input[str] stream_name: Stream id.
        :param pulumi.Input[str] upstream_sequence: Sequence.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BackupStreamArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a css backup_stream

        > **NOTE:** This resource is only valid when the push stream. When the push stream ends, it will be deleted.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        backup_stream = tencentcloud.css.BackupStream("backupStream",
            app_name="live",
            push_domain_name="177154.push.tlivecloud.com",
            stream_name="1308919341_test",
            upstream_sequence="2209501773993286139")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        css backup_stream can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Css/backupStream:BackupStream backup_stream pushDomainName#appName#streamName
        ```

        :param str resource_name: The name of the resource.
        :param BackupStreamArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BackupStreamArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 app_name: Optional[pulumi.Input[str]] = None,
                 push_domain_name: Optional[pulumi.Input[str]] = None,
                 stream_name: Optional[pulumi.Input[str]] = None,
                 upstream_sequence: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BackupStreamArgs.__new__(BackupStreamArgs)

            if app_name is None and not opts.urn:
                raise TypeError("Missing required property 'app_name'")
            __props__.__dict__["app_name"] = app_name
            if push_domain_name is None and not opts.urn:
                raise TypeError("Missing required property 'push_domain_name'")
            __props__.__dict__["push_domain_name"] = push_domain_name
            if stream_name is None and not opts.urn:
                raise TypeError("Missing required property 'stream_name'")
            __props__.__dict__["stream_name"] = stream_name
            if upstream_sequence is None and not opts.urn:
                raise TypeError("Missing required property 'upstream_sequence'")
            __props__.__dict__["upstream_sequence"] = upstream_sequence
        super(BackupStream, __self__).__init__(
            'tencentcloud:Css/backupStream:BackupStream',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            app_name: Optional[pulumi.Input[str]] = None,
            push_domain_name: Optional[pulumi.Input[str]] = None,
            stream_name: Optional[pulumi.Input[str]] = None,
            upstream_sequence: Optional[pulumi.Input[str]] = None) -> 'BackupStream':
        """
        Get an existing BackupStream resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] app_name: App name.
        :param pulumi.Input[str] push_domain_name: Push domain.
        :param pulumi.Input[str] stream_name: Stream id.
        :param pulumi.Input[str] upstream_sequence: Sequence.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BackupStreamState.__new__(_BackupStreamState)

        __props__.__dict__["app_name"] = app_name
        __props__.__dict__["push_domain_name"] = push_domain_name
        __props__.__dict__["stream_name"] = stream_name
        __props__.__dict__["upstream_sequence"] = upstream_sequence
        return BackupStream(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="appName")
    def app_name(self) -> pulumi.Output[str]:
        """
        App name.
        """
        return pulumi.get(self, "app_name")

    @property
    @pulumi.getter(name="pushDomainName")
    def push_domain_name(self) -> pulumi.Output[str]:
        """
        Push domain.
        """
        return pulumi.get(self, "push_domain_name")

    @property
    @pulumi.getter(name="streamName")
    def stream_name(self) -> pulumi.Output[str]:
        """
        Stream id.
        """
        return pulumi.get(self, "stream_name")

    @property
    @pulumi.getter(name="upstreamSequence")
    def upstream_sequence(self) -> pulumi.Output[str]:
        """
        Sequence.
        """
        return pulumi.get(self, "upstream_sequence")

