# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetPadTemplatesResult',
    'AwaitableGetPadTemplatesResult',
    'get_pad_templates',
    'get_pad_templates_output',
]

@pulumi.output_type
class GetPadTemplatesResult:
    """
    A collection of values returned by getPadTemplates.
    """
    def __init__(__self__, id=None, result_output_file=None, templates=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if templates and not isinstance(templates, list):
            raise TypeError("Expected argument 'templates' to be a list")
        pulumi.set(__self__, "templates", templates)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def templates(self) -> Sequence['outputs.GetPadTemplatesTemplateResult']:
        """
        Live pad template information.
        """
        return pulumi.get(self, "templates")


class AwaitableGetPadTemplatesResult(GetPadTemplatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPadTemplatesResult(
            id=self.id,
            result_output_file=self.result_output_file,
            templates=self.templates)


def get_pad_templates(result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPadTemplatesResult:
    """
    Use this data source to query detailed information of css pad_templates

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    pad_templates = tencentcloud.Css.get_pad_templates()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Css/getPadTemplates:getPadTemplates', __args__, opts=opts, typ=GetPadTemplatesResult).value

    return AwaitableGetPadTemplatesResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        templates=pulumi.get(__ret__, 'templates'))


@_utilities.lift_output_func(get_pad_templates)
def get_pad_templates_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPadTemplatesResult]:
    """
    Use this data source to query detailed information of css pad_templates

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    pad_templates = tencentcloud.Css.get_pad_templates()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
