# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetDisasterRecoverGroupQuotaResult',
    'AwaitableGetDisasterRecoverGroupQuotaResult',
    'get_disaster_recover_group_quota',
    'get_disaster_recover_group_quota_output',
]

@pulumi.output_type
class GetDisasterRecoverGroupQuotaResult:
    """
    A collection of values returned by getDisasterRecoverGroupQuota.
    """
    def __init__(__self__, current_num=None, cvm_in_host_group_quota=None, cvm_in_rack_group_quota=None, cvm_in_sw_group_quota=None, group_quota=None, id=None, result_output_file=None):
        if current_num and not isinstance(current_num, int):
            raise TypeError("Expected argument 'current_num' to be a int")
        pulumi.set(__self__, "current_num", current_num)
        if cvm_in_host_group_quota and not isinstance(cvm_in_host_group_quota, int):
            raise TypeError("Expected argument 'cvm_in_host_group_quota' to be a int")
        pulumi.set(__self__, "cvm_in_host_group_quota", cvm_in_host_group_quota)
        if cvm_in_rack_group_quota and not isinstance(cvm_in_rack_group_quota, int):
            raise TypeError("Expected argument 'cvm_in_rack_group_quota' to be a int")
        pulumi.set(__self__, "cvm_in_rack_group_quota", cvm_in_rack_group_quota)
        if cvm_in_sw_group_quota and not isinstance(cvm_in_sw_group_quota, int):
            raise TypeError("Expected argument 'cvm_in_sw_group_quota' to be a int")
        pulumi.set(__self__, "cvm_in_sw_group_quota", cvm_in_sw_group_quota)
        if group_quota and not isinstance(group_quota, int):
            raise TypeError("Expected argument 'group_quota' to be a int")
        pulumi.set(__self__, "group_quota", group_quota)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="currentNum")
    def current_num(self) -> int:
        """
        The number of placement groups that have been created by the current user.
        """
        return pulumi.get(self, "current_num")

    @property
    @pulumi.getter(name="cvmInHostGroupQuota")
    def cvm_in_host_group_quota(self) -> int:
        """
        Quota on instances in a physical-machine-type disaster recovery group.
        """
        return pulumi.get(self, "cvm_in_host_group_quota")

    @property
    @pulumi.getter(name="cvmInRackGroupQuota")
    def cvm_in_rack_group_quota(self) -> int:
        """
        Quota on instances in a rack-type disaster recovery group.
        """
        return pulumi.get(self, "cvm_in_rack_group_quota")

    @property
    @pulumi.getter(name="cvmInSwGroupQuota")
    def cvm_in_sw_group_quota(self) -> int:
        """
        Quota on instances in a switch-type disaster recovery group.
        """
        return pulumi.get(self, "cvm_in_sw_group_quota")

    @property
    @pulumi.getter(name="groupQuota")
    def group_quota(self) -> int:
        """
        The maximum number of placement groups that can be created.
        """
        return pulumi.get(self, "group_quota")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDisasterRecoverGroupQuotaResult(GetDisasterRecoverGroupQuotaResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDisasterRecoverGroupQuotaResult(
            current_num=self.current_num,
            cvm_in_host_group_quota=self.cvm_in_host_group_quota,
            cvm_in_rack_group_quota=self.cvm_in_rack_group_quota,
            cvm_in_sw_group_quota=self.cvm_in_sw_group_quota,
            group_quota=self.group_quota,
            id=self.id,
            result_output_file=self.result_output_file)


def get_disaster_recover_group_quota(result_output_file: Optional[str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDisasterRecoverGroupQuotaResult:
    """
    Use this data source to query detailed information of cvm disaster_recover_group_quota

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    disaster_recover_group_quota = tencentcloud.Cvm.get_disaster_recover_group_quota()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cvm/getDisasterRecoverGroupQuota:getDisasterRecoverGroupQuota', __args__, opts=opts, typ=GetDisasterRecoverGroupQuotaResult).value

    return AwaitableGetDisasterRecoverGroupQuotaResult(
        current_num=pulumi.get(__ret__, 'current_num'),
        cvm_in_host_group_quota=pulumi.get(__ret__, 'cvm_in_host_group_quota'),
        cvm_in_rack_group_quota=pulumi.get(__ret__, 'cvm_in_rack_group_quota'),
        cvm_in_sw_group_quota=pulumi.get(__ret__, 'cvm_in_sw_group_quota'),
        group_quota=pulumi.get(__ret__, 'group_quota'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_disaster_recover_group_quota)
def get_disaster_recover_group_quota_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDisasterRecoverGroupQuotaResult]:
    """
    Use this data source to query detailed information of cvm disaster_recover_group_quota

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    disaster_recover_group_quota = tencentcloud.Cvm.get_disaster_recover_group_quota()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
