# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRollbackTimeRangeResult',
    'AwaitableGetRollbackTimeRangeResult',
    'get_rollback_time_range',
    'get_rollback_time_range_output',
]

@pulumi.output_type
class GetRollbackTimeRangeResult:
    """
    A collection of values returned by getRollbackTimeRange.
    """
    def __init__(__self__, cluster_id=None, id=None, result_output_file=None, rollback_time_ranges=None, time_range_end=None, time_range_start=None):
        if cluster_id and not isinstance(cluster_id, str):
            raise TypeError("Expected argument 'cluster_id' to be a str")
        pulumi.set(__self__, "cluster_id", cluster_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if rollback_time_ranges and not isinstance(rollback_time_ranges, list):
            raise TypeError("Expected argument 'rollback_time_ranges' to be a list")
        pulumi.set(__self__, "rollback_time_ranges", rollback_time_ranges)
        if time_range_end and not isinstance(time_range_end, str):
            raise TypeError("Expected argument 'time_range_end' to be a str")
        pulumi.set(__self__, "time_range_end", time_range_end)
        if time_range_start and not isinstance(time_range_start, str):
            raise TypeError("Expected argument 'time_range_start' to be a str")
        pulumi.set(__self__, "time_range_start", time_range_start)

    @property
    @pulumi.getter(name="clusterId")
    def cluster_id(self) -> str:
        return pulumi.get(self, "cluster_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="rollbackTimeRanges")
    def rollback_time_ranges(self) -> Sequence['outputs.GetRollbackTimeRangeRollbackTimeRangeResult']:
        """
        Reversible time range.
        """
        return pulumi.get(self, "rollback_time_ranges")

    @property
    @pulumi.getter(name="timeRangeEnd")
    def time_range_end(self) -> str:
        """
        Effective regression time range end time point (obsolete) Note: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "time_range_end")

    @property
    @pulumi.getter(name="timeRangeStart")
    def time_range_start(self) -> str:
        """
        Effective regression time range start time point (obsolete) Note: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "time_range_start")


class AwaitableGetRollbackTimeRangeResult(GetRollbackTimeRangeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRollbackTimeRangeResult(
            cluster_id=self.cluster_id,
            id=self.id,
            result_output_file=self.result_output_file,
            rollback_time_ranges=self.rollback_time_ranges,
            time_range_end=self.time_range_end,
            time_range_start=self.time_range_start)


def get_rollback_time_range(cluster_id: Optional[str] = None,
                            result_output_file: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRollbackTimeRangeResult:
    """
    Use this data source to query detailed information of cynosdb rollback_time_range

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    rollback_time_range = tencentcloud.Cynosdb.get_rollback_time_range(cluster_id="cynosdbmysql-bws8h88b")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['clusterId'] = cluster_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Cynosdb/getRollbackTimeRange:getRollbackTimeRange', __args__, opts=opts, typ=GetRollbackTimeRangeResult).value

    return AwaitableGetRollbackTimeRangeResult(
        cluster_id=pulumi.get(__ret__, 'cluster_id'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        rollback_time_ranges=pulumi.get(__ret__, 'rollback_time_ranges'),
        time_range_end=pulumi.get(__ret__, 'time_range_end'),
        time_range_start=pulumi.get(__ret__, 'time_range_start'))


@_utilities.lift_output_func(get_rollback_time_range)
def get_rollback_time_range_output(cluster_id: Optional[pulumi.Input[str]] = None,
                                   result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRollbackTimeRangeResult]:
    """
    Use this data source to query detailed information of cynosdb rollback_time_range

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    rollback_time_range = tencentcloud.Cynosdb.get_rollback_time_range(cluster_id="cynosdbmysql-bws8h88b")
    ```
    <!--End PulumiCodeChooser -->


    :param str cluster_id: Cluster ID.
    :param str result_output_file: Used to save results.
    """
    ...
