# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['CancelDcnJobOperationArgs', 'CancelDcnJobOperation']

@pulumi.input_type
class CancelDcnJobOperationArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a CancelDcnJobOperation resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        """
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _CancelDcnJobOperationState:
    def __init__(__self__, *,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering CancelDcnJobOperation resources.
        :param pulumi.Input[str] instance_id: Instance ID.
        """
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class CancelDcnJobOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a dcdb cancel_dcn_job_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        internal = tencentcloud.Security.get_groups(name="default")
        vpc = tencentcloud.Vpc.get_instances(name="Default-VPC")
        subnet = tencentcloud.Vpc.get_subnets(vpc_id=vpc.instance_lists[0].vpc_id)
        vpc_id = subnet.instance_lists[0].vpc_id
        subnet_id = subnet.instance_lists[0].subnet_id
        sg_id = internal.security_groups[0].security_group_id
        hourdb_instance_dcn = tencentcloud.dcdb.HourdbInstance("hourdbInstanceDcn",
            instance_name="test_dcdb_db_hourdb_instance_dcn",
            zones=[var["default_az"]],
            shard_memory=2,
            shard_storage=10,
            shard_node_count=2,
            shard_count=2,
            vpc_id=vpc_id,
            subnet_id=subnet_id,
            security_group_id=sg_id,
            db_version_id="8.0",
            dcn_region="ap-guangzhou",
            dcn_instance_id=local["dcdb_id"],
            resource_tags=[tencentcloud.dcdb.HourdbInstanceResourceTagArgs(
                tag_key="aaa",
                tag_value="bbb",
            )])
        dcn_dcdb_id = hourdb_instance_dcn.id
        cancel_operation = tencentcloud.dcdb.CancelDcnJobOperation("cancelOperation", instance_id=dcn_dcdb_id)
        # cancel the dcn/readonly instance
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: CancelDcnJobOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dcdb cancel_dcn_job_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        internal = tencentcloud.Security.get_groups(name="default")
        vpc = tencentcloud.Vpc.get_instances(name="Default-VPC")
        subnet = tencentcloud.Vpc.get_subnets(vpc_id=vpc.instance_lists[0].vpc_id)
        vpc_id = subnet.instance_lists[0].vpc_id
        subnet_id = subnet.instance_lists[0].subnet_id
        sg_id = internal.security_groups[0].security_group_id
        hourdb_instance_dcn = tencentcloud.dcdb.HourdbInstance("hourdbInstanceDcn",
            instance_name="test_dcdb_db_hourdb_instance_dcn",
            zones=[var["default_az"]],
            shard_memory=2,
            shard_storage=10,
            shard_node_count=2,
            shard_count=2,
            vpc_id=vpc_id,
            subnet_id=subnet_id,
            security_group_id=sg_id,
            db_version_id="8.0",
            dcn_region="ap-guangzhou",
            dcn_instance_id=local["dcdb_id"],
            resource_tags=[tencentcloud.dcdb.HourdbInstanceResourceTagArgs(
                tag_key="aaa",
                tag_value="bbb",
            )])
        dcn_dcdb_id = hourdb_instance_dcn.id
        cancel_operation = tencentcloud.dcdb.CancelDcnJobOperation("cancelOperation", instance_id=dcn_dcdb_id)
        # cancel the dcn/readonly instance
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param CancelDcnJobOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(CancelDcnJobOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = CancelDcnJobOperationArgs.__new__(CancelDcnJobOperationArgs)

            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(CancelDcnJobOperation, __self__).__init__(
            'tencentcloud:Dcdb/cancelDcnJobOperation:CancelDcnJobOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'CancelDcnJobOperation':
        """
        Get an existing CancelDcnJobOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] instance_id: Instance ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _CancelDcnJobOperationState.__new__(_CancelDcnJobOperationState)

        __props__.__dict__["instance_id"] = instance_id
        return CancelDcnJobOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "instance_id")

