# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrdersResult',
    'AwaitableGetOrdersResult',
    'get_orders',
    'get_orders_output',
]

@pulumi.output_type
class GetOrdersResult:
    """
    A collection of values returned by getOrders.
    """
    def __init__(__self__, deal_names=None, deals=None, id=None, result_output_file=None):
        if deal_names and not isinstance(deal_names, list):
            raise TypeError("Expected argument 'deal_names' to be a list")
        pulumi.set(__self__, "deal_names", deal_names)
        if deals and not isinstance(deals, list):
            raise TypeError("Expected argument 'deals' to be a list")
        pulumi.set(__self__, "deals", deals)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="dealNames")
    def deal_names(self) -> Sequence[str]:
        return pulumi.get(self, "deal_names")

    @property
    @pulumi.getter
    def deals(self) -> Sequence['outputs.GetOrdersDealResult']:
        """
        Order information list.
        """
        return pulumi.get(self, "deals")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetOrdersResult(GetOrdersResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrdersResult(
            deal_names=self.deal_names,
            deals=self.deals,
            id=self.id,
            result_output_file=self.result_output_file)


def get_orders(deal_names: Optional[Sequence[str]] = None,
               result_output_file: Optional[str] = None,
               opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrdersResult:
    """
    Use this data source to query detailed information of dcdb orders

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    orders = tencentcloud.Dcdb.get_orders(deal_names=["2023061224903413767xxxx"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] deal_names: List of long order numbers to be queried, which are returned for the APIs for creating, renewing, or scaling instances.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['dealNames'] = deal_names
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Dcdb/getOrders:getOrders', __args__, opts=opts, typ=GetOrdersResult).value

    return AwaitableGetOrdersResult(
        deal_names=pulumi.get(__ret__, 'deal_names'),
        deals=pulumi.get(__ret__, 'deals'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_orders)
def get_orders_output(deal_names: Optional[pulumi.Input[Sequence[str]]] = None,
                      result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrdersResult]:
    """
    Use this data source to query detailed information of dcdb orders

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    orders = tencentcloud.Dcdb.get_orders(deal_names=["2023061224903413767xxxx"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] deal_names: List of long order numbers to be queried, which are returned for the APIs for creating, renewing, or scaling instances.
    :param str result_output_file: Used to save results.
    """
    ...
