# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DownloadSnapshotOperationArgs', 'DownloadSnapshotOperation']

@pulumi.input_type
class DownloadSnapshotOperationArgs:
    def __init__(__self__, *,
                 domain: pulumi.Input[str],
                 snapshot_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a DownloadSnapshotOperation resource.
        :param pulumi.Input[str] domain: Domain.
        :param pulumi.Input[str] snapshot_id: Snapshot ID.
        """
        pulumi.set(__self__, "domain", domain)
        pulumi.set(__self__, "snapshot_id", snapshot_id)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Input[str]:
        """
        Domain.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: pulumi.Input[str]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> pulumi.Input[str]:
        """
        Snapshot ID.
        """
        return pulumi.get(self, "snapshot_id")

    @snapshot_id.setter
    def snapshot_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "snapshot_id", value)


@pulumi.input_type
class _DownloadSnapshotOperationState:
    def __init__(__self__, *,
                 cos_url: Optional[pulumi.Input[str]] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering DownloadSnapshotOperation resources.
        :param pulumi.Input[str] cos_url: Snapshot download url.
        :param pulumi.Input[str] domain: Domain.
        :param pulumi.Input[str] snapshot_id: Snapshot ID.
        """
        if cos_url is not None:
            pulumi.set(__self__, "cos_url", cos_url)
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if snapshot_id is not None:
            pulumi.set(__self__, "snapshot_id", snapshot_id)

    @property
    @pulumi.getter(name="cosUrl")
    def cos_url(self) -> Optional[pulumi.Input[str]]:
        """
        Snapshot download url.
        """
        return pulumi.get(self, "cos_url")

    @cos_url.setter
    def cos_url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "cos_url", value)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[str]]:
        """
        Domain.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> Optional[pulumi.Input[str]]:
        """
        Snapshot ID.
        """
        return pulumi.get(self, "snapshot_id")

    @snapshot_id.setter
    def snapshot_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "snapshot_id", value)


class DownloadSnapshotOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a dnspod download_snapshot

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        download_snapshot = tencentcloud.dnspod.DownloadSnapshotOperation("downloadSnapshot",
            domain="dnspod.cn",
            snapshot_id="456")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Domain.
        :param pulumi.Input[str] snapshot_id: Snapshot ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DownloadSnapshotOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a dnspod download_snapshot

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        download_snapshot = tencentcloud.dnspod.DownloadSnapshotOperation("downloadSnapshot",
            domain="dnspod.cn",
            snapshot_id="456")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param DownloadSnapshotOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DownloadSnapshotOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 snapshot_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DownloadSnapshotOperationArgs.__new__(DownloadSnapshotOperationArgs)

            if domain is None and not opts.urn:
                raise TypeError("Missing required property 'domain'")
            __props__.__dict__["domain"] = domain
            if snapshot_id is None and not opts.urn:
                raise TypeError("Missing required property 'snapshot_id'")
            __props__.__dict__["snapshot_id"] = snapshot_id
            __props__.__dict__["cos_url"] = None
        super(DownloadSnapshotOperation, __self__).__init__(
            'tencentcloud:Dnspod/downloadSnapshotOperation:DownloadSnapshotOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cos_url: Optional[pulumi.Input[str]] = None,
            domain: Optional[pulumi.Input[str]] = None,
            snapshot_id: Optional[pulumi.Input[str]] = None) -> 'DownloadSnapshotOperation':
        """
        Get an existing DownloadSnapshotOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] cos_url: Snapshot download url.
        :param pulumi.Input[str] domain: Domain.
        :param pulumi.Input[str] snapshot_id: Snapshot ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DownloadSnapshotOperationState.__new__(_DownloadSnapshotOperationState)

        __props__.__dict__["cos_url"] = cos_url
        __props__.__dict__["domain"] = domain
        __props__.__dict__["snapshot_id"] = snapshot_id
        return DownloadSnapshotOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="cosUrl")
    def cos_url(self) -> pulumi.Output[str]:
        """
        Snapshot download url.
        """
        return pulumi.get(self, "cos_url")

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[str]:
        """
        Domain.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter(name="snapshotId")
    def snapshot_id(self) -> pulumi.Output[str]:
        """
        Snapshot ID.
        """
        return pulumi.get(self, "snapshot_id")

