# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RestartInstanceOperationArgs', 'RestartInstanceOperation']

@pulumi.input_type
class RestartInstanceOperationArgs:
    def __init__(__self__, *,
                 instance_id: pulumi.Input[str],
                 force_restart: Optional[pulumi.Input[bool]] = None,
                 restart_mode: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a RestartInstanceOperation resource.
        :param pulumi.Input[str] instance_id: Instance id.
        :param pulumi.Input[bool] force_restart: Force restart. Valid values:
               - true: Forced restart;
               - false: No forced restart;
               default false.
        :param pulumi.Input[int] restart_mode: Restart mode: 0 roll restart; 1 full restart.
        """
        pulumi.set(__self__, "instance_id", instance_id)
        if force_restart is not None:
            pulumi.set(__self__, "force_restart", force_restart)
        if restart_mode is not None:
            pulumi.set(__self__, "restart_mode", restart_mode)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="forceRestart")
    def force_restart(self) -> Optional[pulumi.Input[bool]]:
        """
        Force restart. Valid values:
        - true: Forced restart;
        - false: No forced restart;
        default false.
        """
        return pulumi.get(self, "force_restart")

    @force_restart.setter
    def force_restart(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "force_restart", value)

    @property
    @pulumi.getter(name="restartMode")
    def restart_mode(self) -> Optional[pulumi.Input[int]]:
        """
        Restart mode: 0 roll restart; 1 full restart.
        """
        return pulumi.get(self, "restart_mode")

    @restart_mode.setter
    def restart_mode(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_mode", value)


@pulumi.input_type
class _RestartInstanceOperationState:
    def __init__(__self__, *,
                 force_restart: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 restart_mode: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering RestartInstanceOperation resources.
        :param pulumi.Input[bool] force_restart: Force restart. Valid values:
               - true: Forced restart;
               - false: No forced restart;
               default false.
        :param pulumi.Input[str] instance_id: Instance id.
        :param pulumi.Input[int] restart_mode: Restart mode: 0 roll restart; 1 full restart.
        """
        if force_restart is not None:
            pulumi.set(__self__, "force_restart", force_restart)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if restart_mode is not None:
            pulumi.set(__self__, "restart_mode", restart_mode)

    @property
    @pulumi.getter(name="forceRestart")
    def force_restart(self) -> Optional[pulumi.Input[bool]]:
        """
        Force restart. Valid values:
        - true: Forced restart;
        - false: No forced restart;
        default false.
        """
        return pulumi.get(self, "force_restart")

    @force_restart.setter
    def force_restart(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "force_restart", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="restartMode")
    def restart_mode(self) -> Optional[pulumi.Input[int]]:
        """
        Restart mode: 0 roll restart; 1 full restart.
        """
        return pulumi.get(self, "restart_mode")

    @restart_mode.setter
    def restart_mode(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "restart_mode", value)


class RestartInstanceOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 force_restart: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 restart_mode: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to restart a elasticsearch instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        restart_instance_operation = tencentcloud.elasticsearch.RestartInstanceOperation("restartInstanceOperation", instance_id="es-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] force_restart: Force restart. Valid values:
               - true: Forced restart;
               - false: No forced restart;
               default false.
        :param pulumi.Input[str] instance_id: Instance id.
        :param pulumi.Input[int] restart_mode: Restart mode: 0 roll restart; 1 full restart.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RestartInstanceOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to restart a elasticsearch instance

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        restart_instance_operation = tencentcloud.elasticsearch.RestartInstanceOperation("restartInstanceOperation", instance_id="es-xxxxxx")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param RestartInstanceOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RestartInstanceOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 force_restart: Optional[pulumi.Input[bool]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 restart_mode: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RestartInstanceOperationArgs.__new__(RestartInstanceOperationArgs)

            __props__.__dict__["force_restart"] = force_restart
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["restart_mode"] = restart_mode
        super(RestartInstanceOperation, __self__).__init__(
            'tencentcloud:Elasticsearch/restartInstanceOperation:RestartInstanceOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            force_restart: Optional[pulumi.Input[bool]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            restart_mode: Optional[pulumi.Input[int]] = None) -> 'RestartInstanceOperation':
        """
        Get an existing RestartInstanceOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] force_restart: Force restart. Valid values:
               - true: Forced restart;
               - false: No forced restart;
               default false.
        :param pulumi.Input[str] instance_id: Instance id.
        :param pulumi.Input[int] restart_mode: Restart mode: 0 roll restart; 1 full restart.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RestartInstanceOperationState.__new__(_RestartInstanceOperationState)

        __props__.__dict__["force_restart"] = force_restart
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["restart_mode"] = restart_mode
        return RestartInstanceOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="forceRestart")
    def force_restart(self) -> pulumi.Output[Optional[bool]]:
        """
        Force restart. Valid values:
        - true: Forced restart;
        - false: No forced restart;
        default false.
        """
        return pulumi.get(self, "force_restart")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance id.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="restartMode")
    def restart_mode(self) -> pulumi.Output[Optional[int]]:
        """
        Restart mode: 0 roll restart; 1 full restart.
        """
        return pulumi.get(self, "restart_mode")

