# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'InstanceIpv4',
    'InstanceIpv4Info',
    'Ipv4AddressPrivateIpAddress',
    'Ipv6AddressIpv6Address',
]

@pulumi.output_type
class InstanceIpv4(dict):
    def __init__(__self__, *,
                 ip: str,
                 primary: bool,
                 description: Optional[str] = None):
        """
        :param str ip: Intranet IP.
        :param bool primary: Indicates whether the IP is primary.
        :param str description: Description of the IP, maximum length 25.
        """
        pulumi.set(__self__, "ip", ip)
        pulumi.set(__self__, "primary", primary)
        if description is not None:
            pulumi.set(__self__, "description", description)

    @property
    @pulumi.getter
    def ip(self) -> str:
        """
        Intranet IP.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def primary(self) -> bool:
        """
        Indicates whether the IP is primary.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the IP, maximum length 25.
        """
        return pulumi.get(self, "description")


@pulumi.output_type
class InstanceIpv4Info(dict):
    def __init__(__self__, *,
                 description: Optional[str] = None,
                 ip: Optional[str] = None,
                 primary: Optional[bool] = None):
        """
        :param str description: Description of the IP, maximum length 25.
        :param str ip: Intranet IP.
        :param bool primary: Indicates whether the IP is primary.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if ip is not None:
            pulumi.set(__self__, "ip", ip)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the IP, maximum length 25.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def ip(self) -> Optional[str]:
        """
        Intranet IP.
        """
        return pulumi.get(self, "ip")

    @property
    @pulumi.getter
    def primary(self) -> Optional[bool]:
        """
        Indicates whether the IP is primary.
        """
        return pulumi.get(self, "primary")


@pulumi.output_type
class Ipv4AddressPrivateIpAddress(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "privateIpAddress":
            suggest = "private_ip_address"
        elif key == "addressId":
            suggest = "address_id"
        elif key == "isWanIpBlocked":
            suggest = "is_wan_ip_blocked"
        elif key == "publicIpAddress":
            suggest = "public_ip_address"
        elif key == "qosLevel":
            suggest = "qos_level"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Ipv4AddressPrivateIpAddress. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Ipv4AddressPrivateIpAddress.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Ipv4AddressPrivateIpAddress.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 private_ip_address: str,
                 address_id: Optional[str] = None,
                 description: Optional[str] = None,
                 is_wan_ip_blocked: Optional[bool] = None,
                 primary: Optional[bool] = None,
                 public_ip_address: Optional[str] = None,
                 qos_level: Optional[str] = None,
                 state: Optional[str] = None):
        """
        :param str private_ip_address: Private IP address.
        :param str address_id: EIP instance ID, such as `eip-11112222`.
        :param str description: Private IP description.
        :param bool is_wan_ip_blocked: Whether the public IP is blocked.
        :param bool primary: Whether it is a primary IP.
        :param str public_ip_address: Public IP address.
        :param str qos_level: IP service level. Values: PT` (Gold), `AU` (Silver), `AG `(Bronze) and DEFAULT` (Default).
        :param str state: IP status: `PENDING`: Creating, `MIGRATING`: Migrating, `DELETING`: Deleting, `AVAILABLE`: Available.
        """
        pulumi.set(__self__, "private_ip_address", private_ip_address)
        if address_id is not None:
            pulumi.set(__self__, "address_id", address_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if is_wan_ip_blocked is not None:
            pulumi.set(__self__, "is_wan_ip_blocked", is_wan_ip_blocked)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)
        if public_ip_address is not None:
            pulumi.set(__self__, "public_ip_address", public_ip_address)
        if qos_level is not None:
            pulumi.set(__self__, "qos_level", qos_level)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter(name="privateIpAddress")
    def private_ip_address(self) -> str:
        """
        Private IP address.
        """
        return pulumi.get(self, "private_ip_address")

    @property
    @pulumi.getter(name="addressId")
    def address_id(self) -> Optional[str]:
        """
        EIP instance ID, such as `eip-11112222`.
        """
        return pulumi.get(self, "address_id")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Private IP description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="isWanIpBlocked")
    def is_wan_ip_blocked(self) -> Optional[bool]:
        """
        Whether the public IP is blocked.
        """
        return pulumi.get(self, "is_wan_ip_blocked")

    @property
    @pulumi.getter
    def primary(self) -> Optional[bool]:
        """
        Whether it is a primary IP.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter(name="publicIpAddress")
    def public_ip_address(self) -> Optional[str]:
        """
        Public IP address.
        """
        return pulumi.get(self, "public_ip_address")

    @property
    @pulumi.getter(name="qosLevel")
    def qos_level(self) -> Optional[str]:
        """
        IP service level. Values: PT` (Gold), `AU` (Silver), `AG `(Bronze) and DEFAULT` (Default).
        """
        return pulumi.get(self, "qos_level")

    @property
    @pulumi.getter
    def state(self) -> Optional[str]:
        """
        IP status: `PENDING`: Creating, `MIGRATING`: Migrating, `DELETING`: Deleting, `AVAILABLE`: Available.
        """
        return pulumi.get(self, "state")


@pulumi.output_type
class Ipv6AddressIpv6Address(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addressId":
            suggest = "address_id"
        elif key == "isWanIpBlocked":
            suggest = "is_wan_ip_blocked"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in Ipv6AddressIpv6Address. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        Ipv6AddressIpv6Address.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        Ipv6AddressIpv6Address.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 address: str,
                 address_id: Optional[str] = None,
                 description: Optional[str] = None,
                 is_wan_ip_blocked: Optional[bool] = None,
                 primary: Optional[bool] = None,
                 state: Optional[str] = None):
        """
        :param str address: `IPv6` address, in the form of: `3402:4e00:20:100:0:8cd9:2a67:71f3`.
        :param str address_id: `EIP` instance `ID`, such as:`eip-hxlqja90`.
        :param str description: Description.
        :param bool is_wan_ip_blocked: Whether the public network IP is blocked.
        :param bool primary: Whether to master `IP`.
        :param str state: `IPv6` address status: `PENDING`: pending, `MIGRATING`: migrating, `DELETING`: deleting, `AVAILABLE`: available.
        """
        pulumi.set(__self__, "address", address)
        if address_id is not None:
            pulumi.set(__self__, "address_id", address_id)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if is_wan_ip_blocked is not None:
            pulumi.set(__self__, "is_wan_ip_blocked", is_wan_ip_blocked)
        if primary is not None:
            pulumi.set(__self__, "primary", primary)
        if state is not None:
            pulumi.set(__self__, "state", state)

    @property
    @pulumi.getter
    def address(self) -> str:
        """
        `IPv6` address, in the form of: `3402:4e00:20:100:0:8cd9:2a67:71f3`.
        """
        return pulumi.get(self, "address")

    @property
    @pulumi.getter(name="addressId")
    def address_id(self) -> Optional[str]:
        """
        `EIP` instance `ID`, such as:`eip-hxlqja90`.
        """
        return pulumi.get(self, "address_id")

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="isWanIpBlocked")
    def is_wan_ip_blocked(self) -> Optional[bool]:
        """
        Whether the public network IP is blocked.
        """
        return pulumi.get(self, "is_wan_ip_blocked")

    @property
    @pulumi.getter
    def primary(self) -> Optional[bool]:
        """
        Whether to master `IP`.
        """
        return pulumi.get(self, "primary")

    @property
    @pulumi.getter
    def state(self) -> Optional[str]:
        """
        `IPv6` address status: `PENDING`: pending, `MIGRATING`: migrating, `DELETING`: deleting, `AVAILABLE`: available.
        """
        return pulumi.get(self, "state")


