# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDomainErrorPageInfosResult',
    'AwaitableGetDomainErrorPageInfosResult',
    'get_domain_error_page_infos',
    'get_domain_error_page_infos_output',
]

@pulumi.output_type
class GetDomainErrorPageInfosResult:
    """
    A collection of values returned by getDomainErrorPageInfos.
    """
    def __init__(__self__, error_page_ids=None, error_page_sets=None, id=None, result_output_file=None):
        if error_page_ids and not isinstance(error_page_ids, list):
            raise TypeError("Expected argument 'error_page_ids' to be a list")
        pulumi.set(__self__, "error_page_ids", error_page_ids)
        if error_page_sets and not isinstance(error_page_sets, list):
            raise TypeError("Expected argument 'error_page_sets' to be a list")
        pulumi.set(__self__, "error_page_sets", error_page_sets)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="errorPageIds")
    def error_page_ids(self) -> Sequence[str]:
        return pulumi.get(self, "error_page_ids")

    @property
    @pulumi.getter(name="errorPageSets")
    def error_page_sets(self) -> Sequence['outputs.GetDomainErrorPageInfosErrorPageSetResult']:
        """
        Custom error response configuration setNote: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "error_page_sets")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDomainErrorPageInfosResult(GetDomainErrorPageInfosResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDomainErrorPageInfosResult(
            error_page_ids=self.error_page_ids,
            error_page_sets=self.error_page_sets,
            id=self.id,
            result_output_file=self.result_output_file)


def get_domain_error_page_infos(error_page_ids: Optional[Sequence[str]] = None,
                                result_output_file: Optional[str] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDomainErrorPageInfosResult:
    """
    Use this data source to query detailed information of gaap domain error page infos

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    domain_error_page_infos = tencentcloud.Gaap.get_domain_error_page_infos(error_page_ids=["errorPage-xxxxxx"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] error_page_ids: Customized error ID list, supporting up to 10.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['errorPageIds'] = error_page_ids
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getDomainErrorPageInfos:getDomainErrorPageInfos', __args__, opts=opts, typ=GetDomainErrorPageInfosResult).value

    return AwaitableGetDomainErrorPageInfosResult(
        error_page_ids=pulumi.get(__ret__, 'error_page_ids'),
        error_page_sets=pulumi.get(__ret__, 'error_page_sets'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_domain_error_page_infos)
def get_domain_error_page_infos_output(error_page_ids: Optional[pulumi.Input[Sequence[str]]] = None,
                                       result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                       opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDomainErrorPageInfosResult]:
    """
    Use this data source to query detailed information of gaap domain error page infos

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    domain_error_page_infos = tencentcloud.Gaap.get_domain_error_page_infos(error_page_ids=["errorPage-xxxxxx"])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[str] error_page_ids: Customized error ID list, supporting up to 10.
    :param str result_output_file: Used to save results.
    """
    ...
