# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProxyDetailResult',
    'AwaitableGetProxyDetailResult',
    'get_proxy_detail',
    'get_proxy_detail_output',
]

@pulumi.output_type
class GetProxyDetailResult:
    """
    A collection of values returned by getProxyDetail.
    """
    def __init__(__self__, id=None, proxy_details=None, proxy_id=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if proxy_details and not isinstance(proxy_details, list):
            raise TypeError("Expected argument 'proxy_details' to be a list")
        pulumi.set(__self__, "proxy_details", proxy_details)
        if proxy_id and not isinstance(proxy_id, str):
            raise TypeError("Expected argument 'proxy_id' to be a str")
        pulumi.set(__self__, "proxy_id", proxy_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="proxyDetails")
    def proxy_details(self) -> Sequence['outputs.GetProxyDetailProxyDetailResult']:
        """
        Proxy Detail.
        """
        return pulumi.get(self, "proxy_details")

    @property
    @pulumi.getter(name="proxyId")
    def proxy_id(self) -> str:
        """
        (New parameter) proxy instance ID.Note: This field may return null, indicating that a valid value cannot be obtained.
        """
        return pulumi.get(self, "proxy_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetProxyDetailResult(GetProxyDetailResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProxyDetailResult(
            id=self.id,
            proxy_details=self.proxy_details,
            proxy_id=self.proxy_id,
            result_output_file=self.result_output_file)


def get_proxy_detail(proxy_id: Optional[str] = None,
                     result_output_file: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProxyDetailResult:
    """
    Use this data source to query detailed information of gaap proxy detail

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_detail = tencentcloud.Gaap.get_proxy_detail(proxy_id="link-m9t4yho9")
    ```
    <!--End PulumiCodeChooser -->


    :param str proxy_id: Proxy Id.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['proxyId'] = proxy_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getProxyDetail:getProxyDetail', __args__, opts=opts, typ=GetProxyDetailResult).value

    return AwaitableGetProxyDetailResult(
        id=pulumi.get(__ret__, 'id'),
        proxy_details=pulumi.get(__ret__, 'proxy_details'),
        proxy_id=pulumi.get(__ret__, 'proxy_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_proxy_detail)
def get_proxy_detail_output(proxy_id: Optional[pulumi.Input[str]] = None,
                            result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProxyDetailResult]:
    """
    Use this data source to query detailed information of gaap proxy detail

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_detail = tencentcloud.Gaap.get_proxy_detail(proxy_id="link-m9t4yho9")
    ```
    <!--End PulumiCodeChooser -->


    :param str proxy_id: Proxy Id.
    :param str result_output_file: Used to save results.
    """
    ...
