# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProxyStatisticsResult',
    'AwaitableGetProxyStatisticsResult',
    'get_proxy_statistics',
    'get_proxy_statistics_output',
]

@pulumi.output_type
class GetProxyStatisticsResult:
    """
    A collection of values returned by getProxyStatistics.
    """
    def __init__(__self__, end_time=None, granularity=None, id=None, isp=None, metric_names=None, proxy_id=None, result_output_file=None, start_time=None, statistics_datas=None):
        if end_time and not isinstance(end_time, str):
            raise TypeError("Expected argument 'end_time' to be a str")
        pulumi.set(__self__, "end_time", end_time)
        if granularity and not isinstance(granularity, int):
            raise TypeError("Expected argument 'granularity' to be a int")
        pulumi.set(__self__, "granularity", granularity)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if isp and not isinstance(isp, str):
            raise TypeError("Expected argument 'isp' to be a str")
        pulumi.set(__self__, "isp", isp)
        if metric_names and not isinstance(metric_names, list):
            raise TypeError("Expected argument 'metric_names' to be a list")
        pulumi.set(__self__, "metric_names", metric_names)
        if proxy_id and not isinstance(proxy_id, str):
            raise TypeError("Expected argument 'proxy_id' to be a str")
        pulumi.set(__self__, "proxy_id", proxy_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if start_time and not isinstance(start_time, str):
            raise TypeError("Expected argument 'start_time' to be a str")
        pulumi.set(__self__, "start_time", start_time)
        if statistics_datas and not isinstance(statistics_datas, list):
            raise TypeError("Expected argument 'statistics_datas' to be a list")
        pulumi.set(__self__, "statistics_datas", statistics_datas)

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> str:
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter
    def granularity(self) -> int:
        return pulumi.get(self, "granularity")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def isp(self) -> Optional[str]:
        return pulumi.get(self, "isp")

    @property
    @pulumi.getter(name="metricNames")
    def metric_names(self) -> Sequence[str]:
        return pulumi.get(self, "metric_names")

    @property
    @pulumi.getter(name="proxyId")
    def proxy_id(self) -> str:
        return pulumi.get(self, "proxy_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        return pulumi.get(self, "start_time")

    @property
    @pulumi.getter(name="statisticsDatas")
    def statistics_datas(self) -> Sequence['outputs.GetProxyStatisticsStatisticsDataResult']:
        """
        proxy Statistics.
        """
        return pulumi.get(self, "statistics_datas")


class AwaitableGetProxyStatisticsResult(GetProxyStatisticsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProxyStatisticsResult(
            end_time=self.end_time,
            granularity=self.granularity,
            id=self.id,
            isp=self.isp,
            metric_names=self.metric_names,
            proxy_id=self.proxy_id,
            result_output_file=self.result_output_file,
            start_time=self.start_time,
            statistics_datas=self.statistics_datas)


def get_proxy_statistics(end_time: Optional[str] = None,
                         granularity: Optional[int] = None,
                         isp: Optional[str] = None,
                         metric_names: Optional[Sequence[str]] = None,
                         proxy_id: Optional[str] = None,
                         result_output_file: Optional[str] = None,
                         start_time: Optional[str] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProxyStatisticsResult:
    """
    Use this data source to query detailed information of gaap proxy statistics

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_statistics = tencentcloud.Gaap.get_proxy_statistics(end_time="2024-05-20 23:59:59",
        granularity=300,
        metric_names=[
            "InBandwidth",
            "OutBandwidth",
            "InFlow",
            "OutFlow",
            "InPackets",
            "OutPackets",
            "Concurrent",
            "HttpQPS",
            "HttpsQPS",
            "Latency",
            "PacketLoss",
        ],
        proxy_id="link-m9t4yho9",
        start_time="2024-05-20 00:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str end_time: End Time(2019-03-25 12:00:00).
    :param int granularity: Monitoring granularity, currently supporting 60 300 3600 86400, in seconds.When the time range does not exceed 3 days, support a minimum granularity of 60 seconds;When the time range does not exceed 7 days, support a minimum granularity of 300 seconds;When the time range does not exceed 30 days, the minimum granularity supported is 3600 seconds.
    :param str isp: Operator (valid when the proxy is a three network proxy), supports CMCC, CUCC, CTCC, and merges data from the three operators if null values are passed or not passed.
    :param Sequence[str] metric_names: Metric Names. Valid values: InBandwidth,OutBandwidth, Concurrent, InPackets, OutPackets, PacketLoss, Latency, HttpQPS, HttpsQPS.
    :param str proxy_id: Proxy Id.
    :param str result_output_file: Used to save results.
    :param str start_time: Start Time(2019-03-25 12:00:00).
    """
    __args__ = dict()
    __args__['endTime'] = end_time
    __args__['granularity'] = granularity
    __args__['isp'] = isp
    __args__['metricNames'] = metric_names
    __args__['proxyId'] = proxy_id
    __args__['resultOutputFile'] = result_output_file
    __args__['startTime'] = start_time
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Gaap/getProxyStatistics:getProxyStatistics', __args__, opts=opts, typ=GetProxyStatisticsResult).value

    return AwaitableGetProxyStatisticsResult(
        end_time=pulumi.get(__ret__, 'end_time'),
        granularity=pulumi.get(__ret__, 'granularity'),
        id=pulumi.get(__ret__, 'id'),
        isp=pulumi.get(__ret__, 'isp'),
        metric_names=pulumi.get(__ret__, 'metric_names'),
        proxy_id=pulumi.get(__ret__, 'proxy_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        start_time=pulumi.get(__ret__, 'start_time'),
        statistics_datas=pulumi.get(__ret__, 'statistics_datas'))


@_utilities.lift_output_func(get_proxy_statistics)
def get_proxy_statistics_output(end_time: Optional[pulumi.Input[str]] = None,
                                granularity: Optional[pulumi.Input[int]] = None,
                                isp: Optional[pulumi.Input[Optional[str]]] = None,
                                metric_names: Optional[pulumi.Input[Sequence[str]]] = None,
                                proxy_id: Optional[pulumi.Input[str]] = None,
                                result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                start_time: Optional[pulumi.Input[str]] = None,
                                opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProxyStatisticsResult]:
    """
    Use this data source to query detailed information of gaap proxy statistics

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    proxy_statistics = tencentcloud.Gaap.get_proxy_statistics(end_time="2024-05-20 23:59:59",
        granularity=300,
        metric_names=[
            "InBandwidth",
            "OutBandwidth",
            "InFlow",
            "OutFlow",
            "InPackets",
            "OutPackets",
            "Concurrent",
            "HttpQPS",
            "HttpsQPS",
            "Latency",
            "PacketLoss",
        ],
        proxy_id="link-m9t4yho9",
        start_time="2024-05-20 00:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str end_time: End Time(2019-03-25 12:00:00).
    :param int granularity: Monitoring granularity, currently supporting 60 300 3600 86400, in seconds.When the time range does not exceed 3 days, support a minimum granularity of 60 seconds;When the time range does not exceed 7 days, support a minimum granularity of 300 seconds;When the time range does not exceed 30 days, the minimum granularity supported is 3600 seconds.
    :param str isp: Operator (valid when the proxy is a three network proxy), supports CMCC, CUCC, CTCC, and merges data from the three operators if null values are passed or not passed.
    :param Sequence[str] metric_names: Metric Names. Valid values: InBandwidth,OutBandwidth, Concurrent, InPackets, OutPackets, PacketLoss, Latency, HttpQPS, HttpsQPS.
    :param str proxy_id: Proxy Id.
    :param str result_output_file: Used to save results.
    :param str start_time: Start Time(2019-03-25 12:00:00).
    """
    ...
