# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['VipEipAttachmentArgs', 'VipEipAttachment']

@pulumi.input_type
class VipEipAttachmentArgs:
    def __init__(__self__, *,
                 address_ip: pulumi.Input[str],
                 havip_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a VipEipAttachment resource.
        :param pulumi.Input[str] address_ip: Public address of the EIP.
        :param pulumi.Input[str] havip_id: ID of the attached HA VIP.
        """
        pulumi.set(__self__, "address_ip", address_ip)
        pulumi.set(__self__, "havip_id", havip_id)

    @property
    @pulumi.getter(name="addressIp")
    def address_ip(self) -> pulumi.Input[str]:
        """
        Public address of the EIP.
        """
        return pulumi.get(self, "address_ip")

    @address_ip.setter
    def address_ip(self, value: pulumi.Input[str]):
        pulumi.set(self, "address_ip", value)

    @property
    @pulumi.getter(name="havipId")
    def havip_id(self) -> pulumi.Input[str]:
        """
        ID of the attached HA VIP.
        """
        return pulumi.get(self, "havip_id")

    @havip_id.setter
    def havip_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "havip_id", value)


@pulumi.input_type
class _VipEipAttachmentState:
    def __init__(__self__, *,
                 address_ip: Optional[pulumi.Input[str]] = None,
                 havip_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VipEipAttachment resources.
        :param pulumi.Input[str] address_ip: Public address of the EIP.
        :param pulumi.Input[str] havip_id: ID of the attached HA VIP.
        """
        if address_ip is not None:
            pulumi.set(__self__, "address_ip", address_ip)
        if havip_id is not None:
            pulumi.set(__self__, "havip_id", havip_id)

    @property
    @pulumi.getter(name="addressIp")
    def address_ip(self) -> Optional[pulumi.Input[str]]:
        """
        Public address of the EIP.
        """
        return pulumi.get(self, "address_ip")

    @address_ip.setter
    def address_ip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "address_ip", value)

    @property
    @pulumi.getter(name="havipId")
    def havip_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of the attached HA VIP.
        """
        return pulumi.get(self, "havip_id")

    @havip_id.setter
    def havip_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "havip_id", value)


class VipEipAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_ip: Optional[pulumi.Input[str]] = None,
                 havip_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a HA VIP EIP attachment.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.ha.VipEipAttachment("foo",
            address_ip="1.1.1.1",
            havip_id="havip-kjqwe4ba")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        HA VIP EIP attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Ha/vipEipAttachment:VipEipAttachment foo havip-kjqwe4ba#1.1.1.1
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_ip: Public address of the EIP.
        :param pulumi.Input[str] havip_id: ID of the attached HA VIP.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VipEipAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a HA VIP EIP attachment.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        foo = tencentcloud.ha.VipEipAttachment("foo",
            address_ip="1.1.1.1",
            havip_id="havip-kjqwe4ba")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        HA VIP EIP attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Ha/vipEipAttachment:VipEipAttachment foo havip-kjqwe4ba#1.1.1.1
        ```

        :param str resource_name: The name of the resource.
        :param VipEipAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VipEipAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_ip: Optional[pulumi.Input[str]] = None,
                 havip_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VipEipAttachmentArgs.__new__(VipEipAttachmentArgs)

            if address_ip is None and not opts.urn:
                raise TypeError("Missing required property 'address_ip'")
            __props__.__dict__["address_ip"] = address_ip
            if havip_id is None and not opts.urn:
                raise TypeError("Missing required property 'havip_id'")
            __props__.__dict__["havip_id"] = havip_id
        super(VipEipAttachment, __self__).__init__(
            'tencentcloud:Ha/vipEipAttachment:VipEipAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            address_ip: Optional[pulumi.Input[str]] = None,
            havip_id: Optional[pulumi.Input[str]] = None) -> 'VipEipAttachment':
        """
        Get an existing VipEipAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] address_ip: Public address of the EIP.
        :param pulumi.Input[str] havip_id: ID of the attached HA VIP.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VipEipAttachmentState.__new__(_VipEipAttachmentState)

        __props__.__dict__["address_ip"] = address_ip
        __props__.__dict__["havip_id"] = havip_id
        return VipEipAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addressIp")
    def address_ip(self) -> pulumi.Output[str]:
        """
        Public address of the EIP.
        """
        return pulumi.get(self, "address_ip")

    @property
    @pulumi.getter(name="havipId")
    def havip_id(self) -> pulumi.Output[str]:
        """
        ID of the attached HA VIP.
        """
        return pulumi.get(self, "havip_id")

