# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetWhiteBoxDecryptKeyResult',
    'AwaitableGetWhiteBoxDecryptKeyResult',
    'get_white_box_decrypt_key',
    'get_white_box_decrypt_key_output',
]

@pulumi.output_type
class GetWhiteBoxDecryptKeyResult:
    """
    A collection of values returned by getWhiteBoxDecryptKey.
    """
    def __init__(__self__, decrypt_key=None, id=None, key_id=None, result_output_file=None):
        if decrypt_key and not isinstance(decrypt_key, str):
            raise TypeError("Expected argument 'decrypt_key' to be a str")
        pulumi.set(__self__, "decrypt_key", decrypt_key)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if key_id and not isinstance(key_id, str):
            raise TypeError("Expected argument 'key_id' to be a str")
        pulumi.set(__self__, "key_id", key_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="decryptKey")
    def decrypt_key(self) -> str:
        """
        White box decryption key, base64 encoded.
        """
        return pulumi.get(self, "decrypt_key")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyId")
    def key_id(self) -> str:
        return pulumi.get(self, "key_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetWhiteBoxDecryptKeyResult(GetWhiteBoxDecryptKeyResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWhiteBoxDecryptKeyResult(
            decrypt_key=self.decrypt_key,
            id=self.id,
            key_id=self.key_id,
            result_output_file=self.result_output_file)


def get_white_box_decrypt_key(key_id: Optional[str] = None,
                              result_output_file: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWhiteBoxDecryptKeyResult:
    """
    Use this data source to query detailed information of kms white_box_decrypt_key

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Kms.get_white_box_decrypt_key(key_id="244dab8c-6dad-11ea-80c6-5254006d0810")
    ```
    <!--End PulumiCodeChooser -->


    :param str key_id: Globally unique identifier for the white box key.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['keyId'] = key_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Kms/getWhiteBoxDecryptKey:getWhiteBoxDecryptKey', __args__, opts=opts, typ=GetWhiteBoxDecryptKeyResult).value

    return AwaitableGetWhiteBoxDecryptKeyResult(
        decrypt_key=pulumi.get(__ret__, 'decrypt_key'),
        id=pulumi.get(__ret__, 'id'),
        key_id=pulumi.get(__ret__, 'key_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_white_box_decrypt_key)
def get_white_box_decrypt_key_output(key_id: Optional[pulumi.Input[str]] = None,
                                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWhiteBoxDecryptKeyResult]:
    """
    Use this data source to query detailed information of kms white_box_decrypt_key

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Kms.get_white_box_decrypt_key(key_id="244dab8c-6dad-11ea-80c6-5254006d0810")
    ```
    <!--End PulumiCodeChooser -->


    :param str key_id: Globally unique identifier for the white box key.
    :param str result_output_file: Used to save results.
    """
    ...
