# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetWhiteBoxKeyDetailsResult',
    'AwaitableGetWhiteBoxKeyDetailsResult',
    'get_white_box_key_details',
    'get_white_box_key_details_output',
]

@pulumi.output_type
class GetWhiteBoxKeyDetailsResult:
    """
    A collection of values returned by getWhiteBoxKeyDetails.
    """
    def __init__(__self__, id=None, key_infos=None, key_status=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if key_infos and not isinstance(key_infos, list):
            raise TypeError("Expected argument 'key_infos' to be a list")
        pulumi.set(__self__, "key_infos", key_infos)
        if key_status and not isinstance(key_status, int):
            raise TypeError("Expected argument 'key_status' to be a int")
        pulumi.set(__self__, "key_status", key_status)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="keyInfos")
    def key_infos(self) -> Sequence['outputs.GetWhiteBoxKeyDetailsKeyInfoResult']:
        """
        List of white box key information.
        """
        return pulumi.get(self, "key_infos")

    @property
    @pulumi.getter(name="keyStatus")
    def key_status(self) -> Optional[int]:
        return pulumi.get(self, "key_status")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetWhiteBoxKeyDetailsResult(GetWhiteBoxKeyDetailsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetWhiteBoxKeyDetailsResult(
            id=self.id,
            key_infos=self.key_infos,
            key_status=self.key_status,
            result_output_file=self.result_output_file)


def get_white_box_key_details(key_status: Optional[int] = None,
                              result_output_file: Optional[str] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetWhiteBoxKeyDetailsResult:
    """
    Use this data source to query detailed information of kms white_box_key_details

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Kms.get_white_box_key_details(key_status=0)
    ```
    <!--End PulumiCodeChooser -->


    :param int key_status: Filter condition: status of the key, 0: disabled, 1: enabled.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['keyStatus'] = key_status
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Kms/getWhiteBoxKeyDetails:getWhiteBoxKeyDetails', __args__, opts=opts, typ=GetWhiteBoxKeyDetailsResult).value

    return AwaitableGetWhiteBoxKeyDetailsResult(
        id=pulumi.get(__ret__, 'id'),
        key_infos=pulumi.get(__ret__, 'key_infos'),
        key_status=pulumi.get(__ret__, 'key_status'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_white_box_key_details)
def get_white_box_key_details_output(key_status: Optional[pulumi.Input[Optional[int]]] = None,
                                     result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetWhiteBoxKeyDetailsResult]:
    """
    Use this data source to query detailed information of kms white_box_key_details

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Kms.get_white_box_key_details(key_status=0)
    ```
    <!--End PulumiCodeChooser -->


    :param int key_status: Filter condition: status of the key, 0: disabled, 1: enabled.
    :param str result_output_file: Used to save results.
    """
    ...
