# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetDiskConfigResult',
    'AwaitableGetDiskConfigResult',
    'get_disk_config',
    'get_disk_config_output',
]

@pulumi.output_type
class GetDiskConfigResult:
    """
    A collection of values returned by getDiskConfig.
    """
    def __init__(__self__, disk_config_sets=None, filters=None, id=None, result_output_file=None):
        if disk_config_sets and not isinstance(disk_config_sets, list):
            raise TypeError("Expected argument 'disk_config_sets' to be a list")
        pulumi.set(__self__, "disk_config_sets", disk_config_sets)
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="diskConfigSets")
    def disk_config_sets(self) -> Sequence['outputs.GetDiskConfigDiskConfigSetResult']:
        """
        List of cloud disk configurations.
        """
        return pulumi.get(self, "disk_config_sets")

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetDiskConfigFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDiskConfigResult(GetDiskConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDiskConfigResult(
            disk_config_sets=self.disk_config_sets,
            filters=self.filters,
            id=self.id,
            result_output_file=self.result_output_file)


def get_disk_config(filters: Optional[Sequence[pulumi.InputType['GetDiskConfigFilterArgs']]] = None,
                    result_output_file: Optional[str] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDiskConfigResult:
    """
    Use this data source to query detailed information of lighthouse disk_config

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    disk_config = tencentcloud.Lighthouse.get_disk_config(filters=[tencentcloud.lighthouse.GetDiskConfigFilterArgs(
        name="zone",
        values=["ap-guangzhou-3"],
    )])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[pulumi.InputType['GetDiskConfigFilterArgs']] filters: Filter list.zoneFilter by availability zone.Type: StringRequired: no.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Lighthouse/getDiskConfig:getDiskConfig', __args__, opts=opts, typ=GetDiskConfigResult).value

    return AwaitableGetDiskConfigResult(
        disk_config_sets=pulumi.get(__ret__, 'disk_config_sets'),
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_disk_config)
def get_disk_config_output(filters: Optional[pulumi.Input[Optional[Sequence[pulumi.InputType['GetDiskConfigFilterArgs']]]]] = None,
                           result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDiskConfigResult]:
    """
    Use this data source to query detailed information of lighthouse disk_config

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    disk_config = tencentcloud.Lighthouse.get_disk_config(filters=[tencentcloud.lighthouse.GetDiskConfigFilterArgs(
        name="zone",
        values=["ap-guangzhou-3"],
    )])
    ```
    <!--End PulumiCodeChooser -->


    :param Sequence[pulumi.InputType['GetDiskConfigFilterArgs']] filters: Filter list.zoneFilter by availability zone.Type: StringRequired: no.
    :param str result_output_file: Used to save results.
    """
    ...
