# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetInstanceSpecsResult',
    'AwaitableGetInstanceSpecsResult',
    'get_instance_specs',
    'get_instance_specs_output',
]

@pulumi.output_type
class GetInstanceSpecsResult:
    """
    A collection of values returned by getInstanceSpecs.
    """
    def __init__(__self__, id=None, result_output_file=None, specs=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if specs and not isinstance(specs, list):
            raise TypeError("Expected argument 'specs' to be a list")
        pulumi.set(__self__, "specs", specs)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def specs(self) -> Sequence['outputs.GetInstanceSpecsSpecResult']:
        """
        list of instance specifications.
        """
        return pulumi.get(self, "specs")


class AwaitableGetInstanceSpecsResult(GetInstanceSpecsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetInstanceSpecsResult(
            id=self.id,
            result_output_file=self.result_output_file,
            specs=self.specs)


def get_instance_specs(result_output_file: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetInstanceSpecsResult:
    """
    Use this data source to query detailed information of mariadb instance_specs

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_specs = tencentcloud.Mariadb.get_instance_specs()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mariadb/getInstanceSpecs:getInstanceSpecs', __args__, opts=opts, typ=GetInstanceSpecsResult).value

    return AwaitableGetInstanceSpecsResult(
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        specs=pulumi.get(__ret__, 'specs'))


@_utilities.lift_output_func(get_instance_specs)
def get_instance_specs_output(result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetInstanceSpecsResult]:
    """
    Use this data source to query detailed information of mariadb instance_specs

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    instance_specs = tencentcloud.Mariadb.get_instance_specs()
    ```
    <!--End PulumiCodeChooser -->


    :param str result_output_file: Used to save results.
    """
    ...
