# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['AlarmPolicySetDefaultArgs', 'AlarmPolicySetDefault']

@pulumi.input_type
class AlarmPolicySetDefaultArgs:
    def __init__(__self__, *,
                 module: pulumi.Input[str],
                 policy_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a AlarmPolicySetDefault resource.
        :param pulumi.Input[str] module: Fixed value, as `monitor`.
        :param pulumi.Input[str] policy_id: Policy id.
        """
        pulumi.set(__self__, "module", module)
        pulumi.set(__self__, "policy_id", policy_id)

    @property
    @pulumi.getter
    def module(self) -> pulumi.Input[str]:
        """
        Fixed value, as `monitor`.
        """
        return pulumi.get(self, "module")

    @module.setter
    def module(self, value: pulumi.Input[str]):
        pulumi.set(self, "module", value)

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> pulumi.Input[str]:
        """
        Policy id.
        """
        return pulumi.get(self, "policy_id")

    @policy_id.setter
    def policy_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "policy_id", value)


@pulumi.input_type
class _AlarmPolicySetDefaultState:
    def __init__(__self__, *,
                 module: Optional[pulumi.Input[str]] = None,
                 policy_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AlarmPolicySetDefault resources.
        :param pulumi.Input[str] module: Fixed value, as `monitor`.
        :param pulumi.Input[str] policy_id: Policy id.
        """
        if module is not None:
            pulumi.set(__self__, "module", module)
        if policy_id is not None:
            pulumi.set(__self__, "policy_id", policy_id)

    @property
    @pulumi.getter
    def module(self) -> Optional[pulumi.Input[str]]:
        """
        Fixed value, as `monitor`.
        """
        return pulumi.get(self, "module")

    @module.setter
    def module(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "module", value)

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> Optional[pulumi.Input[str]]:
        """
        Policy id.
        """
        return pulumi.get(self, "policy_id")

    @policy_id.setter
    def policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "policy_id", value)


class AlarmPolicySetDefault(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 module: Optional[pulumi.Input[str]] = None,
                 policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a monitor policy_set_default

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        policy_set_default = tencentcloud.monitor.AlarmPolicySetDefault("policySetDefault",
            module="monitor",
            policy_id="policy-u4iykjkt")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] module: Fixed value, as `monitor`.
        :param pulumi.Input[str] policy_id: Policy id.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AlarmPolicySetDefaultArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a monitor policy_set_default

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        policy_set_default = tencentcloud.monitor.AlarmPolicySetDefault("policySetDefault",
            module="monitor",
            policy_id="policy-u4iykjkt")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param AlarmPolicySetDefaultArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AlarmPolicySetDefaultArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 module: Optional[pulumi.Input[str]] = None,
                 policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AlarmPolicySetDefaultArgs.__new__(AlarmPolicySetDefaultArgs)

            if module is None and not opts.urn:
                raise TypeError("Missing required property 'module'")
            __props__.__dict__["module"] = module
            if policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'policy_id'")
            __props__.__dict__["policy_id"] = policy_id
        super(AlarmPolicySetDefault, __self__).__init__(
            'tencentcloud:Monitor/alarmPolicySetDefault:AlarmPolicySetDefault',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            module: Optional[pulumi.Input[str]] = None,
            policy_id: Optional[pulumi.Input[str]] = None) -> 'AlarmPolicySetDefault':
        """
        Get an existing AlarmPolicySetDefault resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] module: Fixed value, as `monitor`.
        :param pulumi.Input[str] policy_id: Policy id.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AlarmPolicySetDefaultState.__new__(_AlarmPolicySetDefaultState)

        __props__.__dict__["module"] = module
        __props__.__dict__["policy_id"] = policy_id
        return AlarmPolicySetDefault(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def module(self) -> pulumi.Output[str]:
        """
        Fixed value, as `monitor`.
        """
        return pulumi.get(self, "module")

    @property
    @pulumi.getter(name="policyId")
    def policy_id(self) -> pulumi.Output[str]:
        """
        Policy id.
        """
        return pulumi.get(self, "policy_id")

