# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['TmpManageGrafanaAttachmentArgs', 'TmpManageGrafanaAttachment']

@pulumi.input_type
class TmpManageGrafanaAttachmentArgs:
    def __init__(__self__, *,
                 grafana_id: pulumi.Input[str],
                 instance_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a TmpManageGrafanaAttachment resource.
        :param pulumi.Input[str] grafana_id: Grafana instance ID.
        :param pulumi.Input[str] instance_id: Prometheus instance ID.
        """
        pulumi.set(__self__, "grafana_id", grafana_id)
        pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="grafanaId")
    def grafana_id(self) -> pulumi.Input[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "grafana_id")

    @grafana_id.setter
    def grafana_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "grafana_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Prometheus instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)


@pulumi.input_type
class _TmpManageGrafanaAttachmentState:
    def __init__(__self__, *,
                 grafana_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering TmpManageGrafanaAttachment resources.
        :param pulumi.Input[str] grafana_id: Grafana instance ID.
        :param pulumi.Input[str] instance_id: Prometheus instance ID.
        """
        if grafana_id is not None:
            pulumi.set(__self__, "grafana_id", grafana_id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)

    @property
    @pulumi.getter(name="grafanaId")
    def grafana_id(self) -> Optional[pulumi.Input[str]]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "grafana_id")

    @grafana_id.setter
    def grafana_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "grafana_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Prometheus instance ID.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)


class TmpManageGrafanaAttachment(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 grafana_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a monitor tmp_manage_grafana_attachment

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        availability_zone = config.get("availabilityZone")
        if availability_zone is None:
            availability_zone = "ap-guangzhou-4"
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=availability_zone,
            cidr_block="10.0.1.0/24")
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            data_retention_time=30,
            zone=availability_zone,
            tags={
                "createdBy": "terraform",
            })
        foo_grafana_instance = tencentcloud.monitor.GrafanaInstance("fooGrafanaInstance",
            instance_name="tf-grafana",
            vpc_id=vpc.id,
            subnet_ids=[subnet.id],
            grafana_init_password="1234567890",
            enable_internet=False,
            is_destroy=True,
            tags={
                "createdBy": "test",
            })
        foo_tmp_manage_grafana_attachment = tencentcloud.monitor.TmpManageGrafanaAttachment("fooTmpManageGrafanaAttachment",
            grafana_id=foo_grafana_instance.id,
            instance_id=foo_tmp_instance.id)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor tmp_manage_grafana_attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/tmpManageGrafanaAttachment:TmpManageGrafanaAttachment manage_grafana_attachment prom-xxxxxxxx
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] grafana_id: Grafana instance ID.
        :param pulumi.Input[str] instance_id: Prometheus instance ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: TmpManageGrafanaAttachmentArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a monitor tmp_manage_grafana_attachment

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        config = pulumi.Config()
        availability_zone = config.get("availabilityZone")
        if availability_zone is None:
            availability_zone = "ap-guangzhou-4"
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            vpc_id=vpc.id,
            availability_zone=availability_zone,
            cidr_block="10.0.1.0/24")
        foo_tmp_instance = tencentcloud.monitor.TmpInstance("fooTmpInstance",
            instance_name="tf-tmp-instance",
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            data_retention_time=30,
            zone=availability_zone,
            tags={
                "createdBy": "terraform",
            })
        foo_grafana_instance = tencentcloud.monitor.GrafanaInstance("fooGrafanaInstance",
            instance_name="tf-grafana",
            vpc_id=vpc.id,
            subnet_ids=[subnet.id],
            grafana_init_password="1234567890",
            enable_internet=False,
            is_destroy=True,
            tags={
                "createdBy": "test",
            })
        foo_tmp_manage_grafana_attachment = tencentcloud.monitor.TmpManageGrafanaAttachment("fooTmpManageGrafanaAttachment",
            grafana_id=foo_grafana_instance.id,
            instance_id=foo_tmp_instance.id)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        monitor tmp_manage_grafana_attachment can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Monitor/tmpManageGrafanaAttachment:TmpManageGrafanaAttachment manage_grafana_attachment prom-xxxxxxxx
        ```

        :param str resource_name: The name of the resource.
        :param TmpManageGrafanaAttachmentArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(TmpManageGrafanaAttachmentArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 grafana_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = TmpManageGrafanaAttachmentArgs.__new__(TmpManageGrafanaAttachmentArgs)

            if grafana_id is None and not opts.urn:
                raise TypeError("Missing required property 'grafana_id'")
            __props__.__dict__["grafana_id"] = grafana_id
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
        super(TmpManageGrafanaAttachment, __self__).__init__(
            'tencentcloud:Monitor/tmpManageGrafanaAttachment:TmpManageGrafanaAttachment',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            grafana_id: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None) -> 'TmpManageGrafanaAttachment':
        """
        Get an existing TmpManageGrafanaAttachment resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] grafana_id: Grafana instance ID.
        :param pulumi.Input[str] instance_id: Prometheus instance ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _TmpManageGrafanaAttachmentState.__new__(_TmpManageGrafanaAttachmentState)

        __props__.__dict__["grafana_id"] = grafana_id
        __props__.__dict__["instance_id"] = instance_id
        return TmpManageGrafanaAttachment(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="grafanaId")
    def grafana_id(self) -> pulumi.Output[str]:
        """
        Grafana instance ID.
        """
        return pulumi.get(self, "grafana_id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Prometheus instance ID.
        """
        return pulumi.get(self, "instance_id")

