# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetRollbackRangeTimeResult',
    'AwaitableGetRollbackRangeTimeResult',
    'get_rollback_range_time',
    'get_rollback_range_time_output',
]

@pulumi.output_type
class GetRollbackRangeTimeResult:
    """
    A collection of values returned by getRollbackRangeTime.
    """
    def __init__(__self__, backup_region=None, id=None, instance_ids=None, is_remote_zone=None, items=None, result_output_file=None):
        if backup_region and not isinstance(backup_region, str):
            raise TypeError("Expected argument 'backup_region' to be a str")
        pulumi.set(__self__, "backup_region", backup_region)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_ids and not isinstance(instance_ids, list):
            raise TypeError("Expected argument 'instance_ids' to be a list")
        pulumi.set(__self__, "instance_ids", instance_ids)
        if is_remote_zone and not isinstance(is_remote_zone, str):
            raise TypeError("Expected argument 'is_remote_zone' to be a str")
        pulumi.set(__self__, "is_remote_zone", is_remote_zone)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="backupRegion")
    def backup_region(self) -> Optional[str]:
        return pulumi.get(self, "backup_region")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceIds")
    def instance_ids(self) -> Sequence[str]:
        return pulumi.get(self, "instance_ids")

    @property
    @pulumi.getter(name="isRemoteZone")
    def is_remote_zone(self) -> Optional[str]:
        return pulumi.get(self, "is_remote_zone")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetRollbackRangeTimeItemResult']:
        """
        Returned parameter information.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetRollbackRangeTimeResult(GetRollbackRangeTimeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetRollbackRangeTimeResult(
            backup_region=self.backup_region,
            id=self.id,
            instance_ids=self.instance_ids,
            is_remote_zone=self.is_remote_zone,
            items=self.items,
            result_output_file=self.result_output_file)


def get_rollback_range_time(backup_region: Optional[str] = None,
                            instance_ids: Optional[Sequence[str]] = None,
                            is_remote_zone: Optional[str] = None,
                            result_output_file: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetRollbackRangeTimeResult:
    """
    Use this data source to query detailed information of mysql rollback_range_time

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    rollback_range_time = tencentcloud.Mysql.get_rollback_range_time(instance_ids=["cdb-fitq5t9h"])
    ```
    <!--End PulumiCodeChooser -->


    :param str backup_region: If the clone instance is not in the same region as the source instance, fill in the region where the clone instance is located, for example: ap-guangzhou.
    :param Sequence[str] instance_ids: A list of instance IDs, the format of a single instance ID is: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
    :param str is_remote_zone: Whether the clone instance is in the same zone as the source instance, yes: `false`, no: `true`.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['backupRegion'] = backup_region
    __args__['instanceIds'] = instance_ids
    __args__['isRemoteZone'] = is_remote_zone
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Mysql/getRollbackRangeTime:getRollbackRangeTime', __args__, opts=opts, typ=GetRollbackRangeTimeResult).value

    return AwaitableGetRollbackRangeTimeResult(
        backup_region=pulumi.get(__ret__, 'backup_region'),
        id=pulumi.get(__ret__, 'id'),
        instance_ids=pulumi.get(__ret__, 'instance_ids'),
        is_remote_zone=pulumi.get(__ret__, 'is_remote_zone'),
        items=pulumi.get(__ret__, 'items'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_rollback_range_time)
def get_rollback_range_time_output(backup_region: Optional[pulumi.Input[Optional[str]]] = None,
                                   instance_ids: Optional[pulumi.Input[Sequence[str]]] = None,
                                   is_remote_zone: Optional[pulumi.Input[Optional[str]]] = None,
                                   result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetRollbackRangeTimeResult]:
    """
    Use this data source to query detailed information of mysql rollback_range_time

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    rollback_range_time = tencentcloud.Mysql.get_rollback_range_time(instance_ids=["cdb-fitq5t9h"])
    ```
    <!--End PulumiCodeChooser -->


    :param str backup_region: If the clone instance is not in the same region as the source instance, fill in the region where the clone instance is located, for example: ap-guangzhou.
    :param Sequence[str] instance_ids: A list of instance IDs, the format of a single instance ID is: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
    :param str is_remote_zone: Whether the clone instance is in the same zone as the source instance, yes: `false`, no: `true`.
    :param str result_output_file: Used to save results.
    """
    ...
