# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RemoteBackupConfigArgs', 'RemoteBackupConfig']

@pulumi.input_type
class RemoteBackupConfigArgs:
    def __init__(__self__, *,
                 expire_days: pulumi.Input[int],
                 instance_id: pulumi.Input[str],
                 remote_backup_save: pulumi.Input[str],
                 remote_binlog_save: pulumi.Input[str],
                 remote_regions: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        The set of arguments for constructing a RemoteBackupConfig resource.
        :param pulumi.Input[int] expire_days: Remote backup retention time, in days.
        :param pulumi.Input[str] instance_id: Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        :param pulumi.Input[str] remote_backup_save: Remote data backup switch, off - disable remote backup, on - enable remote backup.
        :param pulumi.Input[str] remote_binlog_save: Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remote_regions: User settings off-site backup region list.
        """
        pulumi.set(__self__, "expire_days", expire_days)
        pulumi.set(__self__, "instance_id", instance_id)
        pulumi.set(__self__, "remote_backup_save", remote_backup_save)
        pulumi.set(__self__, "remote_binlog_save", remote_binlog_save)
        pulumi.set(__self__, "remote_regions", remote_regions)

    @property
    @pulumi.getter(name="expireDays")
    def expire_days(self) -> pulumi.Input[int]:
        """
        Remote backup retention time, in days.
        """
        return pulumi.get(self, "expire_days")

    @expire_days.setter
    def expire_days(self, value: pulumi.Input[int]):
        pulumi.set(self, "expire_days", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="remoteBackupSave")
    def remote_backup_save(self) -> pulumi.Input[str]:
        """
        Remote data backup switch, off - disable remote backup, on - enable remote backup.
        """
        return pulumi.get(self, "remote_backup_save")

    @remote_backup_save.setter
    def remote_backup_save(self, value: pulumi.Input[str]):
        pulumi.set(self, "remote_backup_save", value)

    @property
    @pulumi.getter(name="remoteBinlogSave")
    def remote_binlog_save(self) -> pulumi.Input[str]:
        """
        Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        """
        return pulumi.get(self, "remote_binlog_save")

    @remote_binlog_save.setter
    def remote_binlog_save(self, value: pulumi.Input[str]):
        pulumi.set(self, "remote_binlog_save", value)

    @property
    @pulumi.getter(name="remoteRegions")
    def remote_regions(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        User settings off-site backup region list.
        """
        return pulumi.get(self, "remote_regions")

    @remote_regions.setter
    def remote_regions(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "remote_regions", value)


@pulumi.input_type
class _RemoteBackupConfigState:
    def __init__(__self__, *,
                 expire_days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remote_backup_save: Optional[pulumi.Input[str]] = None,
                 remote_binlog_save: Optional[pulumi.Input[str]] = None,
                 remote_regions: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering RemoteBackupConfig resources.
        :param pulumi.Input[int] expire_days: Remote backup retention time, in days.
        :param pulumi.Input[str] instance_id: Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        :param pulumi.Input[str] remote_backup_save: Remote data backup switch, off - disable remote backup, on - enable remote backup.
        :param pulumi.Input[str] remote_binlog_save: Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remote_regions: User settings off-site backup region list.
        """
        if expire_days is not None:
            pulumi.set(__self__, "expire_days", expire_days)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if remote_backup_save is not None:
            pulumi.set(__self__, "remote_backup_save", remote_backup_save)
        if remote_binlog_save is not None:
            pulumi.set(__self__, "remote_binlog_save", remote_binlog_save)
        if remote_regions is not None:
            pulumi.set(__self__, "remote_regions", remote_regions)

    @property
    @pulumi.getter(name="expireDays")
    def expire_days(self) -> Optional[pulumi.Input[int]]:
        """
        Remote backup retention time, in days.
        """
        return pulumi.get(self, "expire_days")

    @expire_days.setter
    def expire_days(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "expire_days", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="remoteBackupSave")
    def remote_backup_save(self) -> Optional[pulumi.Input[str]]:
        """
        Remote data backup switch, off - disable remote backup, on - enable remote backup.
        """
        return pulumi.get(self, "remote_backup_save")

    @remote_backup_save.setter
    def remote_backup_save(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remote_backup_save", value)

    @property
    @pulumi.getter(name="remoteBinlogSave")
    def remote_binlog_save(self) -> Optional[pulumi.Input[str]]:
        """
        Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        """
        return pulumi.get(self, "remote_binlog_save")

    @remote_binlog_save.setter
    def remote_binlog_save(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remote_binlog_save", value)

    @property
    @pulumi.getter(name="remoteRegions")
    def remote_regions(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        User settings off-site backup region list.
        """
        return pulumi.get(self, "remote_regions")

    @remote_regions.setter
    def remote_regions(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "remote_regions", value)


class RemoteBackupConfig(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 expire_days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remote_backup_save: Optional[pulumi.Input[str]] = None,
                 remote_binlog_save: Optional[pulumi.Input[str]] = None,
                 remote_regions: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a mysql remote_backup_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="cdb")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[0].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="mysql test")
        example_instance = tencentcloud.mysql.Instance("exampleInstance",
            internet_service=1,
            engine_version="5.7",
            charge_type="POSTPAID",
            root_password="PassWord123",
            slave_deploy_mode=0,
            availability_zone=zones.zones[0].name,
            slave_sync_mode=1,
            instance_name="tf-example-mysql",
            mem_size=4000,
            volume_size=200,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            intranet_port=3306,
            security_groups=[security_group.id],
            tags={
                "name": "test",
            },
            parameters={
                "character_set_server": "utf8",
                "max_connections": "1000",
            })
        example_remote_backup_config = tencentcloud.mysql.RemoteBackupConfig("exampleRemoteBackupConfig",
            instance_id=example_instance.id,
            remote_backup_save="on",
            remote_binlog_save="on",
            remote_regions=["ap-shanghai"],
            expire_days=7)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mysql remote_backup_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mysql/remoteBackupConfig:RemoteBackupConfig remote_backup_config remote_backup_config_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] expire_days: Remote backup retention time, in days.
        :param pulumi.Input[str] instance_id: Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        :param pulumi.Input[str] remote_backup_save: Remote data backup switch, off - disable remote backup, on - enable remote backup.
        :param pulumi.Input[str] remote_binlog_save: Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remote_regions: User settings off-site backup region list.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RemoteBackupConfigArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a mysql remote_backup_config

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumi_tencentcloud as tencentcloud
        import tencentcloud_iac_pulumi as tencentcloud

        zones = tencentcloud.Availability.get_zones_by_product(product="cdb")
        vpc = tencentcloud.vpc.Instance("vpc", cidr_block="10.0.0.0/16")
        subnet = tencentcloud.subnet.Instance("subnet",
            availability_zone=zones.zones[0].name,
            vpc_id=vpc.id,
            cidr_block="10.0.0.0/16",
            is_multicast=False)
        security_group = tencentcloud.security.Group("securityGroup", description="mysql test")
        example_instance = tencentcloud.mysql.Instance("exampleInstance",
            internet_service=1,
            engine_version="5.7",
            charge_type="POSTPAID",
            root_password="PassWord123",
            slave_deploy_mode=0,
            availability_zone=zones.zones[0].name,
            slave_sync_mode=1,
            instance_name="tf-example-mysql",
            mem_size=4000,
            volume_size=200,
            vpc_id=vpc.id,
            subnet_id=subnet.id,
            intranet_port=3306,
            security_groups=[security_group.id],
            tags={
                "name": "test",
            },
            parameters={
                "character_set_server": "utf8",
                "max_connections": "1000",
            })
        example_remote_backup_config = tencentcloud.mysql.RemoteBackupConfig("exampleRemoteBackupConfig",
            instance_id=example_instance.id,
            remote_backup_save="on",
            remote_binlog_save="on",
            remote_regions=["ap-shanghai"],
            expire_days=7)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        mysql remote_backup_config can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Mysql/remoteBackupConfig:RemoteBackupConfig remote_backup_config remote_backup_config_id
        ```

        :param str resource_name: The name of the resource.
        :param RemoteBackupConfigArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RemoteBackupConfigArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 expire_days: Optional[pulumi.Input[int]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 remote_backup_save: Optional[pulumi.Input[str]] = None,
                 remote_binlog_save: Optional[pulumi.Input[str]] = None,
                 remote_regions: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RemoteBackupConfigArgs.__new__(RemoteBackupConfigArgs)

            if expire_days is None and not opts.urn:
                raise TypeError("Missing required property 'expire_days'")
            __props__.__dict__["expire_days"] = expire_days
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            if remote_backup_save is None and not opts.urn:
                raise TypeError("Missing required property 'remote_backup_save'")
            __props__.__dict__["remote_backup_save"] = remote_backup_save
            if remote_binlog_save is None and not opts.urn:
                raise TypeError("Missing required property 'remote_binlog_save'")
            __props__.__dict__["remote_binlog_save"] = remote_binlog_save
            if remote_regions is None and not opts.urn:
                raise TypeError("Missing required property 'remote_regions'")
            __props__.__dict__["remote_regions"] = remote_regions
        super(RemoteBackupConfig, __self__).__init__(
            'tencentcloud:Mysql/remoteBackupConfig:RemoteBackupConfig',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            expire_days: Optional[pulumi.Input[int]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            remote_backup_save: Optional[pulumi.Input[str]] = None,
            remote_binlog_save: Optional[pulumi.Input[str]] = None,
            remote_regions: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'RemoteBackupConfig':
        """
        Get an existing RemoteBackupConfig resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] expire_days: Remote backup retention time, in days.
        :param pulumi.Input[str] instance_id: Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        :param pulumi.Input[str] remote_backup_save: Remote data backup switch, off - disable remote backup, on - enable remote backup.
        :param pulumi.Input[str] remote_binlog_save: Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] remote_regions: User settings off-site backup region list.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RemoteBackupConfigState.__new__(_RemoteBackupConfigState)

        __props__.__dict__["expire_days"] = expire_days
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["remote_backup_save"] = remote_backup_save
        __props__.__dict__["remote_binlog_save"] = remote_binlog_save
        __props__.__dict__["remote_regions"] = remote_regions
        return RemoteBackupConfig(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="expireDays")
    def expire_days(self) -> pulumi.Output[int]:
        """
        Remote backup retention time, in days.
        """
        return pulumi.get(self, "expire_days")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID, in the format: cdb-c1nl9rpv. Same instance ID as displayed in the ApsaraDB for Console page.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="remoteBackupSave")
    def remote_backup_save(self) -> pulumi.Output[str]:
        """
        Remote data backup switch, off - disable remote backup, on - enable remote backup.
        """
        return pulumi.get(self, "remote_backup_save")

    @property
    @pulumi.getter(name="remoteBinlogSave")
    def remote_binlog_save(self) -> pulumi.Output[str]:
        """
        Off-site log backup switch, off - off off-site backup, on-on off-site backup, only when the parameter RemoteBackupSave is on, the RemoteBinlogSave parameter can be set to on.
        """
        return pulumi.get(self, "remote_binlog_save")

    @property
    @pulumi.getter(name="remoteRegions")
    def remote_regions(self) -> pulumi.Output[Sequence[str]]:
        """
        User settings off-site backup region list.
        """
        return pulumi.get(self, "remote_regions")

