# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSavepointListResult',
    'AwaitableGetSavepointListResult',
    'get_savepoint_list',
    'get_savepoint_list_output',
]

@pulumi.output_type
class GetSavepointListResult:
    """
    A collection of values returned by getSavepointList.
    """
    def __init__(__self__, id=None, job_id=None, result_output_file=None, savepoints=None, work_space_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if job_id and not isinstance(job_id, str):
            raise TypeError("Expected argument 'job_id' to be a str")
        pulumi.set(__self__, "job_id", job_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if savepoints and not isinstance(savepoints, list):
            raise TypeError("Expected argument 'savepoints' to be a list")
        pulumi.set(__self__, "savepoints", savepoints)
        if work_space_id and not isinstance(work_space_id, str):
            raise TypeError("Expected argument 'work_space_id' to be a str")
        pulumi.set(__self__, "work_space_id", work_space_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="jobId")
    def job_id(self) -> str:
        return pulumi.get(self, "job_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def savepoints(self) -> Sequence['outputs.GetSavepointListSavepointResult']:
        """
        Snapshot listNote: This field may return null, indicating that no valid value was found.
        """
        return pulumi.get(self, "savepoints")

    @property
    @pulumi.getter(name="workSpaceId")
    def work_space_id(self) -> Optional[str]:
        return pulumi.get(self, "work_space_id")


class AwaitableGetSavepointListResult(GetSavepointListResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSavepointListResult(
            id=self.id,
            job_id=self.job_id,
            result_output_file=self.result_output_file,
            savepoints=self.savepoints,
            work_space_id=self.work_space_id)


def get_savepoint_list(job_id: Optional[str] = None,
                       result_output_file: Optional[str] = None,
                       work_space_id: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSavepointListResult:
    """
    Use this data source to query detailed information of oceanus savepoint_list

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Oceanus.get_savepoint_list(job_id="cql-314rw6w0",
        work_space_id="space-2idq8wbr")
    ```
    <!--End PulumiCodeChooser -->


    :param str job_id: Job SerialId.
    :param str result_output_file: Used to save results.
    :param str work_space_id: Workspace SerialId.
    """
    __args__ = dict()
    __args__['jobId'] = job_id
    __args__['resultOutputFile'] = result_output_file
    __args__['workSpaceId'] = work_space_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Oceanus/getSavepointList:getSavepointList', __args__, opts=opts, typ=GetSavepointListResult).value

    return AwaitableGetSavepointListResult(
        id=pulumi.get(__ret__, 'id'),
        job_id=pulumi.get(__ret__, 'job_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        savepoints=pulumi.get(__ret__, 'savepoints'),
        work_space_id=pulumi.get(__ret__, 'work_space_id'))


@_utilities.lift_output_func(get_savepoint_list)
def get_savepoint_list_output(job_id: Optional[pulumi.Input[str]] = None,
                              result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              work_space_id: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSavepointListResult]:
    """
    Use this data source to query detailed information of oceanus savepoint_list

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Oceanus.get_savepoint_list(job_id="cql-314rw6w0",
        work_space_id="space-2idq8wbr")
    ```
    <!--End PulumiCodeChooser -->


    :param str job_id: Job SerialId.
    :param str result_output_file: Used to save results.
    :param str work_space_id: Workspace SerialId.
    """
    ...
