# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrgAuthNodeResult',
    'AwaitableGetOrgAuthNodeResult',
    'get_org_auth_node',
    'get_org_auth_node_output',
]

@pulumi.output_type
class GetOrgAuthNodeResult:
    """
    A collection of values returned by getOrgAuthNode.
    """
    def __init__(__self__, auth_name=None, id=None, items=None, result_output_file=None):
        if auth_name and not isinstance(auth_name, str):
            raise TypeError("Expected argument 'auth_name' to be a str")
        pulumi.set(__self__, "auth_name", auth_name)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter(name="authName")
    def auth_name(self) -> Optional[str]:
        """
        Verified company name.
        """
        return pulumi.get(self, "auth_name")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetOrgAuthNodeItemResult']:
        """
        Organization auth node list.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetOrgAuthNodeResult(GetOrgAuthNodeResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrgAuthNodeResult(
            auth_name=self.auth_name,
            id=self.id,
            items=self.items,
            result_output_file=self.result_output_file)


def get_org_auth_node(auth_name: Optional[str] = None,
                      result_output_file: Optional[str] = None,
                      opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrgAuthNodeResult:
    """
    Use this data source to query detailed information of organization org_auth_node

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    org_auth_node = tencentcloud.Organization.get_org_auth_node()
    ```
    <!--End PulumiCodeChooser -->


    :param str auth_name: Verified company name.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['authName'] = auth_name
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Organization/getOrgAuthNode:getOrgAuthNode', __args__, opts=opts, typ=GetOrgAuthNodeResult).value

    return AwaitableGetOrgAuthNodeResult(
        auth_name=pulumi.get(__ret__, 'auth_name'),
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_org_auth_node)
def get_org_auth_node_output(auth_name: Optional[pulumi.Input[Optional[str]]] = None,
                             result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrgAuthNodeResult]:
    """
    Use this data source to query detailed information of organization org_auth_node

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    org_auth_node = tencentcloud.Organization.get_org_auth_node()
    ```
    <!--End PulumiCodeChooser -->


    :param str auth_name: Verified company name.
    :param str result_output_file: Used to save results.
    """
    ...
