# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetOrgShareAreaResult',
    'AwaitableGetOrgShareAreaResult',
    'get_org_share_area',
    'get_org_share_area_output',
]

@pulumi.output_type
class GetOrgShareAreaResult:
    """
    A collection of values returned by getOrgShareArea.
    """
    def __init__(__self__, id=None, items=None, lang=None, result_output_file=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if items and not isinstance(items, list):
            raise TypeError("Expected argument 'items' to be a list")
        pulumi.set(__self__, "items", items)
        if lang and not isinstance(lang, str):
            raise TypeError("Expected argument 'lang' to be a str")
        pulumi.set(__self__, "lang", lang)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def items(self) -> Sequence['outputs.GetOrgShareAreaItemResult']:
        """
        Area list.
        """
        return pulumi.get(self, "items")

    @property
    @pulumi.getter
    def lang(self) -> Optional[str]:
        return pulumi.get(self, "lang")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetOrgShareAreaResult(GetOrgShareAreaResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOrgShareAreaResult(
            id=self.id,
            items=self.items,
            lang=self.lang,
            result_output_file=self.result_output_file)


def get_org_share_area(lang: Optional[str] = None,
                       result_output_file: Optional[str] = None,
                       opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOrgShareAreaResult:
    """
    Use this data source to query detailed information of organization org_share_area

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    org_share_area = tencentcloud.Organization.get_org_share_area(lang="zh")
    ```
    <!--End PulumiCodeChooser -->


    :param str lang: Language.default zh.
           Valid values:
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['lang'] = lang
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Organization/getOrgShareArea:getOrgShareArea', __args__, opts=opts, typ=GetOrgShareAreaResult).value

    return AwaitableGetOrgShareAreaResult(
        id=pulumi.get(__ret__, 'id'),
        items=pulumi.get(__ret__, 'items'),
        lang=pulumi.get(__ret__, 'lang'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_org_share_area)
def get_org_share_area_output(lang: Optional[pulumi.Input[Optional[str]]] = None,
                              result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                              opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetOrgShareAreaResult]:
    """
    Use this data source to query detailed information of organization org_share_area

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    org_share_area = tencentcloud.Organization.get_org_share_area(lang="zh")
    ```
    <!--End PulumiCodeChooser -->


    :param str lang: Language.default zh.
           Valid values:
    :param str result_output_file: Used to save results.
    """
    ...
