# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['OrgNodeArgs', 'OrgNode']

@pulumi.input_type
class OrgNodeArgs:
    def __init__(__self__, *,
                 parent_node_id: pulumi.Input[int],
                 name: Optional[pulumi.Input[str]] = None,
                 remark: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a OrgNode resource.
        :param pulumi.Input[int] parent_node_id: Parent node ID.
        :param pulumi.Input[str] name: Node name.
        :param pulumi.Input[str] remark: Notes.
        """
        pulumi.set(__self__, "parent_node_id", parent_node_id)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)

    @property
    @pulumi.getter(name="parentNodeId")
    def parent_node_id(self) -> pulumi.Input[int]:
        """
        Parent node ID.
        """
        return pulumi.get(self, "parent_node_id")

    @parent_node_id.setter
    def parent_node_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "parent_node_id", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Node name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[str]]:
        """
        Notes.
        """
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remark", value)


@pulumi.input_type
class _OrgNodeState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 parent_node_id: Optional[pulumi.Input[int]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 update_time: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering OrgNode resources.
        :param pulumi.Input[str] create_time: Node creation time.
        :param pulumi.Input[str] name: Node name.
        :param pulumi.Input[int] parent_node_id: Parent node ID.
        :param pulumi.Input[str] remark: Notes.
        :param pulumi.Input[str] update_time: Node update time.
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if parent_node_id is not None:
            pulumi.set(__self__, "parent_node_id", parent_node_id)
        if remark is not None:
            pulumi.set(__self__, "remark", remark)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Node creation time.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Node name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="parentNodeId")
    def parent_node_id(self) -> Optional[pulumi.Input[int]]:
        """
        Parent node ID.
        """
        return pulumi.get(self, "parent_node_id")

    @parent_node_id.setter
    def parent_node_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "parent_node_id", value)

    @property
    @pulumi.getter
    def remark(self) -> Optional[pulumi.Input[str]]:
        """
        Notes.
        """
        return pulumi.get(self, "remark")

    @remark.setter
    def remark(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "remark", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        Node update time.
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)


class OrgNode(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 parent_node_id: Optional[pulumi.Input[int]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a organization org_node

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        org_node = tencentcloud.organization.OrgNode("orgNode",
            parent_node_id=2003721,
            remark="for terraform test")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization org_node can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Organization/orgNode:OrgNode org_node orgNode_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] name: Node name.
        :param pulumi.Input[int] parent_node_id: Parent node ID.
        :param pulumi.Input[str] remark: Notes.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OrgNodeArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a organization org_node

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        org_node = tencentcloud.organization.OrgNode("orgNode",
            parent_node_id=2003721,
            remark="for terraform test")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization org_node can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Organization/orgNode:OrgNode org_node orgNode_id
        ```

        :param str resource_name: The name of the resource.
        :param OrgNodeArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OrgNodeArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 parent_node_id: Optional[pulumi.Input[int]] = None,
                 remark: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OrgNodeArgs.__new__(OrgNodeArgs)

            __props__.__dict__["name"] = name
            if parent_node_id is None and not opts.urn:
                raise TypeError("Missing required property 'parent_node_id'")
            __props__.__dict__["parent_node_id"] = parent_node_id
            __props__.__dict__["remark"] = remark
            __props__.__dict__["create_time"] = None
            __props__.__dict__["update_time"] = None
        super(OrgNode, __self__).__init__(
            'tencentcloud:Organization/orgNode:OrgNode',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            parent_node_id: Optional[pulumi.Input[int]] = None,
            remark: Optional[pulumi.Input[str]] = None,
            update_time: Optional[pulumi.Input[str]] = None) -> 'OrgNode':
        """
        Get an existing OrgNode resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Node creation time.
        :param pulumi.Input[str] name: Node name.
        :param pulumi.Input[int] parent_node_id: Parent node ID.
        :param pulumi.Input[str] remark: Notes.
        :param pulumi.Input[str] update_time: Node update time.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OrgNodeState.__new__(_OrgNodeState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["name"] = name
        __props__.__dict__["parent_node_id"] = parent_node_id
        __props__.__dict__["remark"] = remark
        __props__.__dict__["update_time"] = update_time
        return OrgNode(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Node creation time.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Node name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="parentNodeId")
    def parent_node_id(self) -> pulumi.Output[int]:
        """
        Parent node ID.
        """
        return pulumi.get(self, "parent_node_id")

    @property
    @pulumi.getter
    def remark(self) -> pulumi.Output[Optional[str]]:
        """
        Notes.
        """
        return pulumi.get(self, "remark")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        Node update time.
        """
        return pulumi.get(self, "update_time")

