# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['QuitOrganizationOperationArgs', 'QuitOrganizationOperation']

@pulumi.input_type
class QuitOrganizationOperationArgs:
    def __init__(__self__, *,
                 org_id: pulumi.Input[int]):
        """
        The set of arguments for constructing a QuitOrganizationOperation resource.
        :param pulumi.Input[int] org_id: Organization ID.
        """
        pulumi.set(__self__, "org_id", org_id)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Input[int]:
        """
        Organization ID.
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "org_id", value)


@pulumi.input_type
class _QuitOrganizationOperationState:
    def __init__(__self__, *,
                 org_id: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering QuitOrganizationOperation resources.
        :param pulumi.Input[int] org_id: Organization ID.
        """
        if org_id is not None:
            pulumi.set(__self__, "org_id", org_id)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> Optional[pulumi.Input[int]]:
        """
        Organization ID.
        """
        return pulumi.get(self, "org_id")

    @org_id.setter
    def org_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "org_id", value)


class QuitOrganizationOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 org_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        Provides a resource to create a organization quit_organization_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        quit_organization_operation = tencentcloud.organization.QuitOrganizationOperation("quitOrganizationOperation", org_id=45155)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization quit_organization_operation can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Organization/quitOrganizationOperation:QuitOrganizationOperation quit_organization_operation quit_organization_operation_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] org_id: Organization ID.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: QuitOrganizationOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a organization quit_organization_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        quit_organization_operation = tencentcloud.organization.QuitOrganizationOperation("quitOrganizationOperation", org_id=45155)
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        organization quit_organization_operation can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Organization/quitOrganizationOperation:QuitOrganizationOperation quit_organization_operation quit_organization_operation_id
        ```

        :param str resource_name: The name of the resource.
        :param QuitOrganizationOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(QuitOrganizationOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 org_id: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = QuitOrganizationOperationArgs.__new__(QuitOrganizationOperationArgs)

            if org_id is None and not opts.urn:
                raise TypeError("Missing required property 'org_id'")
            __props__.__dict__["org_id"] = org_id
        super(QuitOrganizationOperation, __self__).__init__(
            'tencentcloud:Organization/quitOrganizationOperation:QuitOrganizationOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            org_id: Optional[pulumi.Input[int]] = None) -> 'QuitOrganizationOperation':
        """
        Get an existing QuitOrganizationOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] org_id: Organization ID.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _QuitOrganizationOperationState.__new__(_QuitOrganizationOperationState)

        __props__.__dict__["org_id"] = org_id
        return QuitOrganizationOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="orgId")
    def org_id(self) -> pulumi.Output[int]:
        """
        Organization ID.
        """
        return pulumi.get(self, "org_id")

