# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['BaseBackupArgs', 'BaseBackup']

@pulumi.input_type
class BaseBackupArgs:
    def __init__(__self__, *,
                 db_instance_id: pulumi.Input[str],
                 new_expire_time: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None):
        """
        The set of arguments for constructing a BaseBackup resource.
        :param pulumi.Input[str] db_instance_id: Instance ID.
        :param pulumi.Input[str] new_expire_time: New expiration time.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        pulumi.set(__self__, "db_instance_id", db_instance_id)
        if new_expire_time is not None:
            pulumi.set(__self__, "new_expire_time", new_expire_time)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Input[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter(name="newExpireTime")
    def new_expire_time(self) -> Optional[pulumi.Input[str]]:
        """
        New expiration time.
        """
        return pulumi.get(self, "new_expire_time")

    @new_expire_time.setter
    def new_expire_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "new_expire_time", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)


@pulumi.input_type
class _BaseBackupState:
    def __init__(__self__, *,
                 base_backup_id: Optional[pulumi.Input[str]] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 new_expire_time: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None):
        """
        Input properties used for looking up and filtering BaseBackup resources.
        :param pulumi.Input[str] base_backup_id: Base backup ID.
        :param pulumi.Input[str] db_instance_id: Instance ID.
        :param pulumi.Input[str] new_expire_time: New expiration time.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        if base_backup_id is not None:
            pulumi.set(__self__, "base_backup_id", base_backup_id)
        if db_instance_id is not None:
            pulumi.set(__self__, "db_instance_id", db_instance_id)
        if new_expire_time is not None:
            pulumi.set(__self__, "new_expire_time", new_expire_time)
        if tags is not None:
            pulumi.set(__self__, "tags", tags)

    @property
    @pulumi.getter(name="baseBackupId")
    def base_backup_id(self) -> Optional[pulumi.Input[str]]:
        """
        Base backup ID.
        """
        return pulumi.get(self, "base_backup_id")

    @base_backup_id.setter
    def base_backup_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "base_backup_id", value)

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        Instance ID.
        """
        return pulumi.get(self, "db_instance_id")

    @db_instance_id.setter
    def db_instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "db_instance_id", value)

    @property
    @pulumi.getter(name="newExpireTime")
    def new_expire_time(self) -> Optional[pulumi.Input[str]]:
        """
        New expiration time.
        """
        return pulumi.get(self, "new_expire_time")

    @new_expire_time.setter
    def new_expire_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "new_expire_time", value)

    @property
    @pulumi.getter
    def tags(self) -> Optional[pulumi.Input[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

    @tags.setter
    def tags(self, value: Optional[pulumi.Input[Mapping[str, Any]]]):
        pulumi.set(self, "tags", value)


class BaseBackup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 new_expire_time: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 __props__=None):
        """
        Provides a resource to create a postgresql base_backup

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        base_backup = tencentcloud.postgresql.BaseBackup("baseBackup",
            db_instance_id=local["pgsql_id"],
            tags={
                "createdBy": "terraform",
            })
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] db_instance_id: Instance ID.
        :param pulumi.Input[str] new_expire_time: New expiration time.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: BaseBackupArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a postgresql base_backup

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        base_backup = tencentcloud.postgresql.BaseBackup("baseBackup",
            db_instance_id=local["pgsql_id"],
            tags={
                "createdBy": "terraform",
            })
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param BaseBackupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(BaseBackupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id: Optional[pulumi.Input[str]] = None,
                 new_expire_time: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Mapping[str, Any]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = BaseBackupArgs.__new__(BaseBackupArgs)

            if db_instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'db_instance_id'")
            __props__.__dict__["db_instance_id"] = db_instance_id
            __props__.__dict__["new_expire_time"] = new_expire_time
            __props__.__dict__["tags"] = tags
            __props__.__dict__["base_backup_id"] = None
        super(BaseBackup, __self__).__init__(
            'tencentcloud:Postgresql/baseBackup:BaseBackup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            base_backup_id: Optional[pulumi.Input[str]] = None,
            db_instance_id: Optional[pulumi.Input[str]] = None,
            new_expire_time: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Mapping[str, Any]]] = None) -> 'BaseBackup':
        """
        Get an existing BaseBackup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] base_backup_id: Base backup ID.
        :param pulumi.Input[str] db_instance_id: Instance ID.
        :param pulumi.Input[str] new_expire_time: New expiration time.
        :param pulumi.Input[Mapping[str, Any]] tags: Tag description list.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _BaseBackupState.__new__(_BaseBackupState)

        __props__.__dict__["base_backup_id"] = base_backup_id
        __props__.__dict__["db_instance_id"] = db_instance_id
        __props__.__dict__["new_expire_time"] = new_expire_time
        __props__.__dict__["tags"] = tags
        return BaseBackup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="baseBackupId")
    def base_backup_id(self) -> pulumi.Output[str]:
        """
        Base backup ID.
        """
        return pulumi.get(self, "base_backup_id")

    @property
    @pulumi.getter(name="dbInstanceId")
    def db_instance_id(self) -> pulumi.Output[str]:
        """
        Instance ID.
        """
        return pulumi.get(self, "db_instance_id")

    @property
    @pulumi.getter(name="newExpireTime")
    def new_expire_time(self) -> pulumi.Output[str]:
        """
        New expiration time.
        """
        return pulumi.get(self, "new_expire_time")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Mapping[str, Any]]]:
        """
        Tag description list.
        """
        return pulumi.get(self, "tags")

