# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['IsolateDbInstanceOperationArgs', 'IsolateDbInstanceOperation']

@pulumi.input_type
class IsolateDbInstanceOperationArgs:
    def __init__(__self__, *,
                 db_instance_id_sets: pulumi.Input[Sequence[pulumi.Input[str]]]):
        """
        The set of arguments for constructing a IsolateDbInstanceOperation resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_instance_id_sets: List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        pulumi.set(__self__, "db_instance_id_sets", db_instance_id_sets)

    @property
    @pulumi.getter(name="dbInstanceIdSets")
    def db_instance_id_sets(self) -> pulumi.Input[Sequence[pulumi.Input[str]]]:
        """
        List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        return pulumi.get(self, "db_instance_id_sets")

    @db_instance_id_sets.setter
    def db_instance_id_sets(self, value: pulumi.Input[Sequence[pulumi.Input[str]]]):
        pulumi.set(self, "db_instance_id_sets", value)


@pulumi.input_type
class _IsolateDbInstanceOperationState:
    def __init__(__self__, *,
                 db_instance_id_sets: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None):
        """
        Input properties used for looking up and filtering IsolateDbInstanceOperation resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_instance_id_sets: List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        if db_instance_id_sets is not None:
            pulumi.set(__self__, "db_instance_id_sets", db_instance_id_sets)

    @property
    @pulumi.getter(name="dbInstanceIdSets")
    def db_instance_id_sets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        return pulumi.get(self, "db_instance_id_sets")

    @db_instance_id_sets.setter
    def db_instance_id_sets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "db_instance_id_sets", value)


class IsolateDbInstanceOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id_sets: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        """
        Provides a resource to create a postgresql isolate_db_instance_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        isolate_db_instance_operation = tencentcloud.postgresql.IsolateDbInstanceOperation("isolateDbInstanceOperation", db_instance_id_sets=[local["pgsql_id"]])
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_instance_id_sets: List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: IsolateDbInstanceOperationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a postgresql isolate_db_instance_operation

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        isolate_db_instance_operation = tencentcloud.postgresql.IsolateDbInstanceOperation("isolateDbInstanceOperation", db_instance_id_sets=[local["pgsql_id"]])
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param IsolateDbInstanceOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(IsolateDbInstanceOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 db_instance_id_sets: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = IsolateDbInstanceOperationArgs.__new__(IsolateDbInstanceOperationArgs)

            if db_instance_id_sets is None and not opts.urn:
                raise TypeError("Missing required property 'db_instance_id_sets'")
            __props__.__dict__["db_instance_id_sets"] = db_instance_id_sets
        super(IsolateDbInstanceOperation, __self__).__init__(
            'tencentcloud:Postgresql/isolateDbInstanceOperation:IsolateDbInstanceOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            db_instance_id_sets: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None) -> 'IsolateDbInstanceOperation':
        """
        Get an existing IsolateDbInstanceOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] db_instance_id_sets: List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _IsolateDbInstanceOperationState.__new__(_IsolateDbInstanceOperationState)

        __props__.__dict__["db_instance_id_sets"] = db_instance_id_sets
        return IsolateDbInstanceOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dbInstanceIdSets")
    def db_instance_id_sets(self) -> pulumi.Output[Sequence[str]]:
        """
        List of resource IDs. Note that currently you cannot isolate multiple instances at the same time. Only one instance ID can be passed in here.
        """
        return pulumi.get(self, "db_instance_id_sets")

