# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetZoneConfigResult',
    'AwaitableGetZoneConfigResult',
    'get_zone_config',
    'get_zone_config_output',
]

@pulumi.output_type
class GetZoneConfigResult:
    """
    A collection of values returned by getZoneConfig.
    """
    def __init__(__self__, id=None, lists=None, region=None, result_output_file=None, type_id=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if lists and not isinstance(lists, list):
            raise TypeError("Expected argument 'lists' to be a list")
        pulumi.set(__self__, "lists", lists)
        if region and not isinstance(region, str):
            raise TypeError("Expected argument 'region' to be a str")
        pulumi.set(__self__, "region", region)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if type_id and not isinstance(type_id, int):
            raise TypeError("Expected argument 'type_id' to be a int")
        pulumi.set(__self__, "type_id", type_id)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def lists(self) -> Sequence['outputs.GetZoneConfigListResult']:
        """
        A list of zone. Each element contains the following attributes:
        """
        return pulumi.get(self, "lists")

    @property
    @pulumi.getter
    def region(self) -> Optional[str]:
        return pulumi.get(self, "region")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="typeId")
    def type_id(self) -> Optional[int]:
        """
        Instance type. Which redis type supports in this zone.
        """
        return pulumi.get(self, "type_id")


class AwaitableGetZoneConfigResult(GetZoneConfigResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetZoneConfigResult(
            id=self.id,
            lists=self.lists,
            region=self.region,
            result_output_file=self.result_output_file,
            type_id=self.type_id)


def get_zone_config(region: Optional[str] = None,
                    result_output_file: Optional[str] = None,
                    type_id: Optional[int] = None,
                    opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetZoneConfigResult:
    """
    Use this data source to query which instance types of Redis are available in a specific region.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redislab = tencentcloud.Redis.get_zone_config(region="ap-hongkong",
        result_output_file="/temp/mytestpath")
    ```
    <!--End PulumiCodeChooser -->


    :param str region: Name of a region. If this value is not set, the current region getting from provider's configuration will be used.
    :param str result_output_file: Used to save results.
    :param int type_id: Instance type ID.
    """
    __args__ = dict()
    __args__['region'] = region
    __args__['resultOutputFile'] = result_output_file
    __args__['typeId'] = type_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Redis/getZoneConfig:getZoneConfig', __args__, opts=opts, typ=GetZoneConfigResult).value

    return AwaitableGetZoneConfigResult(
        id=pulumi.get(__ret__, 'id'),
        lists=pulumi.get(__ret__, 'lists'),
        region=pulumi.get(__ret__, 'region'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        type_id=pulumi.get(__ret__, 'type_id'))


@_utilities.lift_output_func(get_zone_config)
def get_zone_config_output(region: Optional[pulumi.Input[Optional[str]]] = None,
                           result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                           type_id: Optional[pulumi.Input[Optional[int]]] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetZoneConfigResult]:
    """
    Use this data source to query which instance types of Redis are available in a specific region.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    redislab = tencentcloud.Redis.get_zone_config(region="ap-hongkong",
        result_output_file="/temp/mytestpath")
    ```
    <!--End PulumiCodeChooser -->


    :param str region: Name of a region. If this value is not set, the current region getting from provider's configuration will be used.
    :param str result_output_file: Used to save results.
    :param int type_id: Instance type ID.
    """
    ...
