# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetSendEmailStatusResult',
    'AwaitableGetSendEmailStatusResult',
    'get_send_email_status',
    'get_send_email_status_output',
]

@pulumi.output_type
class GetSendEmailStatusResult:
    """
    A collection of values returned by getSendEmailStatus.
    """
    def __init__(__self__, email_status_lists=None, id=None, message_id=None, request_date=None, result_output_file=None, to_email_address=None):
        if email_status_lists and not isinstance(email_status_lists, list):
            raise TypeError("Expected argument 'email_status_lists' to be a list")
        pulumi.set(__self__, "email_status_lists", email_status_lists)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if message_id and not isinstance(message_id, str):
            raise TypeError("Expected argument 'message_id' to be a str")
        pulumi.set(__self__, "message_id", message_id)
        if request_date and not isinstance(request_date, str):
            raise TypeError("Expected argument 'request_date' to be a str")
        pulumi.set(__self__, "request_date", request_date)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if to_email_address and not isinstance(to_email_address, str):
            raise TypeError("Expected argument 'to_email_address' to be a str")
        pulumi.set(__self__, "to_email_address", to_email_address)

    @property
    @pulumi.getter(name="emailStatusLists")
    def email_status_lists(self) -> Sequence['outputs.GetSendEmailStatusEmailStatusListResult']:
        """
        Status of sent emails.
        """
        return pulumi.get(self, "email_status_lists")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="messageId")
    def message_id(self) -> Optional[str]:
        """
        The MessageId field returned by the SendEmail API.
        """
        return pulumi.get(self, "message_id")

    @property
    @pulumi.getter(name="requestDate")
    def request_date(self) -> str:
        return pulumi.get(self, "request_date")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="toEmailAddress")
    def to_email_address(self) -> Optional[str]:
        """
        Recipient email address.
        """
        return pulumi.get(self, "to_email_address")


class AwaitableGetSendEmailStatusResult(GetSendEmailStatusResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSendEmailStatusResult(
            email_status_lists=self.email_status_lists,
            id=self.id,
            message_id=self.message_id,
            request_date=self.request_date,
            result_output_file=self.result_output_file,
            to_email_address=self.to_email_address)


def get_send_email_status(message_id: Optional[str] = None,
                          request_date: Optional[str] = None,
                          result_output_file: Optional[str] = None,
                          to_email_address: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSendEmailStatusResult:
    """
    Use this data source to query detailed information of ses send_email_status

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    send_email_status = tencentcloud.Ses.get_send_email_status(message_id="qcloudses-30-4123414323-date-20210101094334-syNARhMTbKI1",
        request_date="2020-09-22",
        to_email_address="example@cloud.com")
    ```
    <!--End PulumiCodeChooser -->


    :param str message_id: The MessageId field returned by the SendMail API.
    :param str request_date: Date sent. This parameter is required. You can only query the sending status for a single date at a time.
    :param str result_output_file: Used to save results.
    :param str to_email_address: Recipient email address.
    """
    __args__ = dict()
    __args__['messageId'] = message_id
    __args__['requestDate'] = request_date
    __args__['resultOutputFile'] = result_output_file
    __args__['toEmailAddress'] = to_email_address
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ses/getSendEmailStatus:getSendEmailStatus', __args__, opts=opts, typ=GetSendEmailStatusResult).value

    return AwaitableGetSendEmailStatusResult(
        email_status_lists=pulumi.get(__ret__, 'email_status_lists'),
        id=pulumi.get(__ret__, 'id'),
        message_id=pulumi.get(__ret__, 'message_id'),
        request_date=pulumi.get(__ret__, 'request_date'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        to_email_address=pulumi.get(__ret__, 'to_email_address'))


@_utilities.lift_output_func(get_send_email_status)
def get_send_email_status_output(message_id: Optional[pulumi.Input[Optional[str]]] = None,
                                 request_date: Optional[pulumi.Input[str]] = None,
                                 result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                 to_email_address: Optional[pulumi.Input[Optional[str]]] = None,
                                 opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSendEmailStatusResult]:
    """
    Use this data source to query detailed information of ses send_email_status

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    send_email_status = tencentcloud.Ses.get_send_email_status(message_id="qcloudses-30-4123414323-date-20210101094334-syNARhMTbKI1",
        request_date="2020-09-22",
        to_email_address="example@cloud.com")
    ```
    <!--End PulumiCodeChooser -->


    :param str message_id: The MessageId field returned by the SendMail API.
    :param str request_date: Date sent. This parameter is required. You can only query the sending status for a single date at a time.
    :param str result_output_file: Used to save results.
    :param str to_email_address: Recipient email address.
    """
    ...
