# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['VerifyDomainArgs', 'VerifyDomain']

@pulumi.input_type
class VerifyDomainArgs:
    def __init__(__self__, *,
                 email_identity: pulumi.Input[str]):
        """
        The set of arguments for constructing a VerifyDomain resource.
        :param pulumi.Input[str] email_identity: Domain name requested for verification.
        """
        pulumi.set(__self__, "email_identity", email_identity)

    @property
    @pulumi.getter(name="emailIdentity")
    def email_identity(self) -> pulumi.Input[str]:
        """
        Domain name requested for verification.
        """
        return pulumi.get(self, "email_identity")

    @email_identity.setter
    def email_identity(self, value: pulumi.Input[str]):
        pulumi.set(self, "email_identity", value)


@pulumi.input_type
class _VerifyDomainState:
    def __init__(__self__, *,
                 email_identity: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering VerifyDomain resources.
        :param pulumi.Input[str] email_identity: Domain name requested for verification.
        """
        if email_identity is not None:
            pulumi.set(__self__, "email_identity", email_identity)

    @property
    @pulumi.getter(name="emailIdentity")
    def email_identity(self) -> Optional[pulumi.Input[str]]:
        """
        Domain name requested for verification.
        """
        return pulumi.get(self, "email_identity")

    @email_identity.setter
    def email_identity(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "email_identity", value)


class VerifyDomain(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 email_identity: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a ses verify_domain

        > **NOTE:** Please add the `attributes` information returned by `Ses.Domain` to the domain name resolution record through `Dnspod.Record`, and then verify it.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        verify_domain = tencentcloud.ses.VerifyDomain("verifyDomain", email_identity="example.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] email_identity: Domain name requested for verification.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: VerifyDomainArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a ses verify_domain

        > **NOTE:** Please add the `attributes` information returned by `Ses.Domain` to the domain name resolution record through `Dnspod.Record`, and then verify it.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        verify_domain = tencentcloud.ses.VerifyDomain("verifyDomain", email_identity="example.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param VerifyDomainArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(VerifyDomainArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 email_identity: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = VerifyDomainArgs.__new__(VerifyDomainArgs)

            if email_identity is None and not opts.urn:
                raise TypeError("Missing required property 'email_identity'")
            __props__.__dict__["email_identity"] = email_identity
        super(VerifyDomain, __self__).__init__(
            'tencentcloud:Ses/verifyDomain:VerifyDomain',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            email_identity: Optional[pulumi.Input[str]] = None) -> 'VerifyDomain':
        """
        Get an existing VerifyDomain resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] email_identity: Domain name requested for verification.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _VerifyDomainState.__new__(_VerifyDomainState)

        __props__.__dict__["email_identity"] = email_identity
        return VerifyDomain(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="emailIdentity")
    def email_identity(self) -> pulumi.Output[str]:
        """
        Domain name requested for verification.
        """
        return pulumi.get(self, "email_identity")

