# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetQueryXeventResult',
    'AwaitableGetQueryXeventResult',
    'get_query_xevent',
    'get_query_xevent_output',
]

@pulumi.output_type
class GetQueryXeventResult:
    """
    A collection of values returned by getQueryXevent.
    """
    def __init__(__self__, end_time=None, event_type=None, events=None, id=None, instance_id=None, result_output_file=None, start_time=None):
        if end_time and not isinstance(end_time, str):
            raise TypeError("Expected argument 'end_time' to be a str")
        pulumi.set(__self__, "end_time", end_time)
        if event_type and not isinstance(event_type, str):
            raise TypeError("Expected argument 'event_type' to be a str")
        pulumi.set(__self__, "event_type", event_type)
        if events and not isinstance(events, list):
            raise TypeError("Expected argument 'events' to be a list")
        pulumi.set(__self__, "events", events)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if instance_id and not isinstance(instance_id, str):
            raise TypeError("Expected argument 'instance_id' to be a str")
        pulumi.set(__self__, "instance_id", instance_id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if start_time and not isinstance(start_time, str):
            raise TypeError("Expected argument 'start_time' to be a str")
        pulumi.set(__self__, "start_time", start_time)

    @property
    @pulumi.getter(name="endTime")
    def end_time(self) -> str:
        """
        Generation end time of an extended file.
        """
        return pulumi.get(self, "end_time")

    @property
    @pulumi.getter(name="eventType")
    def event_type(self) -> str:
        """
        Event type. Valid values: slow (Slow SQL event), blocked (blocking event), deadlock (deadlock event).
        """
        return pulumi.get(self, "event_type")

    @property
    @pulumi.getter
    def events(self) -> Sequence['outputs.GetQueryXeventEventResult']:
        """
        List of extended events.
        """
        return pulumi.get(self, "events")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> str:
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="startTime")
    def start_time(self) -> str:
        """
        Generation start time of an extended file.
        """
        return pulumi.get(self, "start_time")


class AwaitableGetQueryXeventResult(GetQueryXeventResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetQueryXeventResult(
            end_time=self.end_time,
            event_type=self.event_type,
            events=self.events,
            id=self.id,
            instance_id=self.instance_id,
            result_output_file=self.result_output_file,
            start_time=self.start_time)


def get_query_xevent(end_time: Optional[str] = None,
                     event_type: Optional[str] = None,
                     instance_id: Optional[str] = None,
                     result_output_file: Optional[str] = None,
                     start_time: Optional[str] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetQueryXeventResult:
    """
    Use this data source to query detailed information of sqlserver query_xevent

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_query_xevent(end_time="2023-08-10 00:00:00",
        event_type="blocked",
        instance_id="mssql-gyg9xycl",
        start_time="2023-08-01 00:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str end_time: Generation end time of an extended file.
    :param str event_type: Event type. Valid values: slow (Slow SQL event), blocked (blocking event), deadlock` (deadlock event).
    :param str instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    :param str start_time: Generation start time of an extended file.
    """
    __args__ = dict()
    __args__['endTime'] = end_time
    __args__['eventType'] = event_type
    __args__['instanceId'] = instance_id
    __args__['resultOutputFile'] = result_output_file
    __args__['startTime'] = start_time
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Sqlserver/getQueryXevent:getQueryXevent', __args__, opts=opts, typ=GetQueryXeventResult).value

    return AwaitableGetQueryXeventResult(
        end_time=pulumi.get(__ret__, 'end_time'),
        event_type=pulumi.get(__ret__, 'event_type'),
        events=pulumi.get(__ret__, 'events'),
        id=pulumi.get(__ret__, 'id'),
        instance_id=pulumi.get(__ret__, 'instance_id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        start_time=pulumi.get(__ret__, 'start_time'))


@_utilities.lift_output_func(get_query_xevent)
def get_query_xevent_output(end_time: Optional[pulumi.Input[str]] = None,
                            event_type: Optional[pulumi.Input[str]] = None,
                            instance_id: Optional[pulumi.Input[str]] = None,
                            result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                            start_time: Optional[pulumi.Input[str]] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetQueryXeventResult]:
    """
    Use this data source to query detailed information of sqlserver query_xevent

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    example = tencentcloud.Sqlserver.get_query_xevent(end_time="2023-08-10 00:00:00",
        event_type="blocked",
        instance_id="mssql-gyg9xycl",
        start_time="2023-08-01 00:00:00")
    ```
    <!--End PulumiCodeChooser -->


    :param str end_time: Generation end time of an extended file.
    :param str event_type: Event type. Valid values: slow (Slow SQL event), blocked (blocking event), deadlock` (deadlock event).
    :param str instance_id: Instance ID.
    :param str result_output_file: Used to save results.
    :param str start_time: Generation start time of an extended file.
    """
    ...
