# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['IncreBackupMigrationArgs', 'IncreBackupMigration']

@pulumi.input_type
class IncreBackupMigrationArgs:
    def __init__(__self__, *,
                 backup_migration_id: pulumi.Input[str],
                 instance_id: pulumi.Input[str],
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 is_recovery: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a IncreBackupMigration resource.
        :param pulumi.Input[str] backup_migration_id: Backup import task ID, which is returned through the API CreateBackupMigration.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] is_recovery: Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        pulumi.set(__self__, "backup_migration_id", backup_migration_id)
        pulumi.set(__self__, "instance_id", instance_id)
        if backup_files is not None:
            pulumi.set(__self__, "backup_files", backup_files)
        if is_recovery is not None:
            pulumi.set(__self__, "is_recovery", is_recovery)

    @property
    @pulumi.getter(name="backupMigrationId")
    def backup_migration_id(self) -> pulumi.Input[str]:
        """
        Backup import task ID, which is returned through the API CreateBackupMigration.
        """
        return pulumi.get(self, "backup_migration_id")

    @backup_migration_id.setter
    def backup_migration_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "backup_migration_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Input[str]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @backup_files.setter
    def backup_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "backup_files", value)

    @property
    @pulumi.getter(name="isRecovery")
    def is_recovery(self) -> Optional[pulumi.Input[str]]:
        """
        Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        return pulumi.get(self, "is_recovery")

    @is_recovery.setter
    def is_recovery(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "is_recovery", value)


@pulumi.input_type
class _IncreBackupMigrationState:
    def __init__(__self__, *,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 backup_migration_id: Optional[pulumi.Input[str]] = None,
                 incremental_migration_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 is_recovery: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering IncreBackupMigration resources.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] backup_migration_id: Backup import task ID, which is returned through the API CreateBackupMigration.
        :param pulumi.Input[str] incremental_migration_id: Incremental import task ID.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] is_recovery: Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        if backup_files is not None:
            pulumi.set(__self__, "backup_files", backup_files)
        if backup_migration_id is not None:
            pulumi.set(__self__, "backup_migration_id", backup_migration_id)
        if incremental_migration_id is not None:
            pulumi.set(__self__, "incremental_migration_id", incremental_migration_id)
        if instance_id is not None:
            pulumi.set(__self__, "instance_id", instance_id)
        if is_recovery is not None:
            pulumi.set(__self__, "is_recovery", is_recovery)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @backup_files.setter
    def backup_files(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "backup_files", value)

    @property
    @pulumi.getter(name="backupMigrationId")
    def backup_migration_id(self) -> Optional[pulumi.Input[str]]:
        """
        Backup import task ID, which is returned through the API CreateBackupMigration.
        """
        return pulumi.get(self, "backup_migration_id")

    @backup_migration_id.setter
    def backup_migration_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "backup_migration_id", value)

    @property
    @pulumi.getter(name="incrementalMigrationId")
    def incremental_migration_id(self) -> Optional[pulumi.Input[str]]:
        """
        Incremental import task ID.
        """
        return pulumi.get(self, "incremental_migration_id")

    @incremental_migration_id.setter
    def incremental_migration_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "incremental_migration_id", value)

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> Optional[pulumi.Input[str]]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @instance_id.setter
    def instance_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "instance_id", value)

    @property
    @pulumi.getter(name="isRecovery")
    def is_recovery(self) -> Optional[pulumi.Input[str]]:
        """
        Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        return pulumi.get(self, "is_recovery")

    @is_recovery.setter
    def is_recovery(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "is_recovery", value)


class IncreBackupMigration(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 backup_migration_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 is_recovery: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a sqlserver incre_backup_migration

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.sqlserver.IncreBackupMigration("example",
            backup_files=[],
            backup_migration_id="mssql-backup-migration-9tj0sxnz",
            instance_id="mssql-4gmc5805",
            is_recovery="YES")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        sqlserver incre_backup_migration can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Sqlserver/increBackupMigration:IncreBackupMigration incre_backup_migration incre_backup_migration_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] backup_migration_id: Backup import task ID, which is returned through the API CreateBackupMigration.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] is_recovery: Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: IncreBackupMigrationArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a sqlserver incre_backup_migration

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        example = tencentcloud.sqlserver.IncreBackupMigration("example",
            backup_files=[],
            backup_migration_id="mssql-backup-migration-9tj0sxnz",
            instance_id="mssql-4gmc5805",
            is_recovery="YES")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        sqlserver incre_backup_migration can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Sqlserver/increBackupMigration:IncreBackupMigration incre_backup_migration incre_backup_migration_id
        ```

        :param str resource_name: The name of the resource.
        :param IncreBackupMigrationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(IncreBackupMigrationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 backup_migration_id: Optional[pulumi.Input[str]] = None,
                 instance_id: Optional[pulumi.Input[str]] = None,
                 is_recovery: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = IncreBackupMigrationArgs.__new__(IncreBackupMigrationArgs)

            __props__.__dict__["backup_files"] = backup_files
            if backup_migration_id is None and not opts.urn:
                raise TypeError("Missing required property 'backup_migration_id'")
            __props__.__dict__["backup_migration_id"] = backup_migration_id
            if instance_id is None and not opts.urn:
                raise TypeError("Missing required property 'instance_id'")
            __props__.__dict__["instance_id"] = instance_id
            __props__.__dict__["is_recovery"] = is_recovery
            __props__.__dict__["incremental_migration_id"] = None
        super(IncreBackupMigration, __self__).__init__(
            'tencentcloud:Sqlserver/increBackupMigration:IncreBackupMigration',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            backup_files: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            backup_migration_id: Optional[pulumi.Input[str]] = None,
            incremental_migration_id: Optional[pulumi.Input[str]] = None,
            instance_id: Optional[pulumi.Input[str]] = None,
            is_recovery: Optional[pulumi.Input[str]] = None) -> 'IncreBackupMigration':
        """
        Get an existing IncreBackupMigration resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] backup_files: Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        :param pulumi.Input[str] backup_migration_id: Backup import task ID, which is returned through the API CreateBackupMigration.
        :param pulumi.Input[str] incremental_migration_id: Incremental import task ID.
        :param pulumi.Input[str] instance_id: ID of imported target instance.
        :param pulumi.Input[str] is_recovery: Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _IncreBackupMigrationState.__new__(_IncreBackupMigrationState)

        __props__.__dict__["backup_files"] = backup_files
        __props__.__dict__["backup_migration_id"] = backup_migration_id
        __props__.__dict__["incremental_migration_id"] = incremental_migration_id
        __props__.__dict__["instance_id"] = instance_id
        __props__.__dict__["is_recovery"] = is_recovery
        return IncreBackupMigration(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="backupFiles")
    def backup_files(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Incremental backup file. If the UploadType of a full backup file is COS_URL, fill in URL here. If the UploadType is COS_UPLOAD, fill in the name of the backup file here. Only 1 backup file is supported, but a backup file can involve multiple databases.
        """
        return pulumi.get(self, "backup_files")

    @property
    @pulumi.getter(name="backupMigrationId")
    def backup_migration_id(self) -> pulumi.Output[str]:
        """
        Backup import task ID, which is returned through the API CreateBackupMigration.
        """
        return pulumi.get(self, "backup_migration_id")

    @property
    @pulumi.getter(name="incrementalMigrationId")
    def incremental_migration_id(self) -> pulumi.Output[str]:
        """
        Incremental import task ID.
        """
        return pulumi.get(self, "incremental_migration_id")

    @property
    @pulumi.getter(name="instanceId")
    def instance_id(self) -> pulumi.Output[str]:
        """
        ID of imported target instance.
        """
        return pulumi.get(self, "instance_id")

    @property
    @pulumi.getter(name="isRecovery")
    def is_recovery(self) -> pulumi.Output[Optional[str]]:
        """
        Whether restoration is required. No: not required. Yes: required. Not required by default.
        """
        return pulumi.get(self, "is_recovery")

