# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDescribeCertificateResult',
    'AwaitableGetDescribeCertificateResult',
    'get_describe_certificate',
    'get_describe_certificate_output',
]

@pulumi.output_type
class GetDescribeCertificateResult:
    """
    A collection of values returned by getDescribeCertificate.
    """
    def __init__(__self__, certificate_id=None, id=None, result_output_file=None, results=None):
        if certificate_id and not isinstance(certificate_id, str):
            raise TypeError("Expected argument 'certificate_id' to be a str")
        pulumi.set(__self__, "certificate_id", certificate_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter(name="certificateId")
    def certificate_id(self) -> str:
        return pulumi.get(self, "certificate_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetDescribeCertificateResultResult']:
        """
        result list.
        """
        return pulumi.get(self, "results")


class AwaitableGetDescribeCertificateResult(GetDescribeCertificateResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDescribeCertificateResult(
            certificate_id=self.certificate_id,
            id=self.id,
            result_output_file=self.result_output_file,
            results=self.results)


def get_describe_certificate(certificate_id: Optional[str] = None,
                             result_output_file: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDescribeCertificateResult:
    """
    Use this data source to query detailed information of ssl describe_certificate

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_certificate = tencentcloud.Ssl.get_describe_certificate(certificate_id="8cj4g8h8")
    ```
    <!--End PulumiCodeChooser -->


    :param str certificate_id: Certificate ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['certificateId'] = certificate_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ssl/getDescribeCertificate:getDescribeCertificate', __args__, opts=opts, typ=GetDescribeCertificateResult).value

    return AwaitableGetDescribeCertificateResult(
        certificate_id=pulumi.get(__ret__, 'certificate_id'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        results=pulumi.get(__ret__, 'results'))


@_utilities.lift_output_func(get_describe_certificate)
def get_describe_certificate_output(certificate_id: Optional[pulumi.Input[str]] = None,
                                    result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDescribeCertificateResult]:
    """
    Use this data source to query detailed information of ssl describe_certificate

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_certificate = tencentcloud.Ssl.get_describe_certificate(certificate_id="8cj4g8h8")
    ```
    <!--End PulumiCodeChooser -->


    :param str certificate_id: Certificate ID.
    :param str result_output_file: Used to save results.
    """
    ...
