# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetDescribeCompaniesResult',
    'AwaitableGetDescribeCompaniesResult',
    'get_describe_companies',
    'get_describe_companies_output',
]

@pulumi.output_type
class GetDescribeCompaniesResult:
    """
    A collection of values returned by getDescribeCompanies.
    """
    def __init__(__self__, companies=None, company_id=None, id=None, result_output_file=None):
        if companies and not isinstance(companies, list):
            raise TypeError("Expected argument 'companies' to be a list")
        pulumi.set(__self__, "companies", companies)
        if company_id and not isinstance(company_id, int):
            raise TypeError("Expected argument 'company_id' to be a int")
        pulumi.set(__self__, "company_id", company_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)

    @property
    @pulumi.getter
    def companies(self) -> Sequence['outputs.GetDescribeCompaniesCompanyResult']:
        """
        Company list.
        """
        return pulumi.get(self, "companies")

    @property
    @pulumi.getter(name="companyId")
    def company_id(self) -> Optional[int]:
        """
        Company ID.
        """
        return pulumi.get(self, "company_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")


class AwaitableGetDescribeCompaniesResult(GetDescribeCompaniesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetDescribeCompaniesResult(
            companies=self.companies,
            company_id=self.company_id,
            id=self.id,
            result_output_file=self.result_output_file)


def get_describe_companies(company_id: Optional[int] = None,
                           result_output_file: Optional[str] = None,
                           opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetDescribeCompaniesResult:
    """
    Use this data source to query detailed information of ssl describe_companies

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_companies = tencentcloud.Ssl.get_describe_companies(company_id=122)
    ```
    <!--End PulumiCodeChooser -->


    :param int company_id: Company ID.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['companyId'] = company_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Ssl/getDescribeCompanies:getDescribeCompanies', __args__, opts=opts, typ=GetDescribeCompaniesResult).value

    return AwaitableGetDescribeCompaniesResult(
        companies=pulumi.get(__ret__, 'companies'),
        company_id=pulumi.get(__ret__, 'company_id'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'))


@_utilities.lift_output_func(get_describe_companies)
def get_describe_companies_output(company_id: Optional[pulumi.Input[Optional[int]]] = None,
                                  result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                  opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetDescribeCompaniesResult]:
    """
    Use this data source to query detailed information of ssl describe_companies

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    describe_companies = tencentcloud.Ssl.get_describe_companies(company_id=122)
    ```
    <!--End PulumiCodeChooser -->


    :param int company_id: Company ID.
    :param str result_output_file: Used to save results.
    """
    ...
