# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['UpdateCertificateRecordRollbackOperationArgs', 'UpdateCertificateRecordRollbackOperation']

@pulumi.input_type
class UpdateCertificateRecordRollbackOperationArgs:
    def __init__(__self__, *,
                 deploy_record_id: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a UpdateCertificateRecordRollbackOperation resource.
        :param pulumi.Input[str] deploy_record_id: Deployment record ID to be rolled back.
        """
        if deploy_record_id is not None:
            pulumi.set(__self__, "deploy_record_id", deploy_record_id)

    @property
    @pulumi.getter(name="deployRecordId")
    def deploy_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Deployment record ID to be rolled back.
        """
        return pulumi.get(self, "deploy_record_id")

    @deploy_record_id.setter
    def deploy_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deploy_record_id", value)


@pulumi.input_type
class _UpdateCertificateRecordRollbackOperationState:
    def __init__(__self__, *,
                 deploy_record_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering UpdateCertificateRecordRollbackOperation resources.
        :param pulumi.Input[str] deploy_record_id: Deployment record ID to be rolled back.
        """
        if deploy_record_id is not None:
            pulumi.set(__self__, "deploy_record_id", deploy_record_id)

    @property
    @pulumi.getter(name="deployRecordId")
    def deploy_record_id(self) -> Optional[pulumi.Input[str]]:
        """
        Deployment record ID to be rolled back.
        """
        return pulumi.get(self, "deploy_record_id")

    @deploy_record_id.setter
    def deploy_record_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "deploy_record_id", value)


class UpdateCertificateRecordRollbackOperation(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 deploy_record_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a ssl update_certificate_record_rollback

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        update_certificate_record_rollback = tencentcloud.ssl.UpdateCertificateRecordRollbackOperation("updateCertificateRecordRollback", deploy_record_id="1603")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        ssl update_certificate_record_rollback can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Ssl/updateCertificateRecordRollbackOperation:UpdateCertificateRecordRollbackOperation update_certificate_record_rollback update_certificate_record_rollback_id
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] deploy_record_id: Deployment record ID to be rolled back.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[UpdateCertificateRecordRollbackOperationArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a ssl update_certificate_record_rollback

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        update_certificate_record_rollback = tencentcloud.ssl.UpdateCertificateRecordRollbackOperation("updateCertificateRecordRollback", deploy_record_id="1603")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        ssl update_certificate_record_rollback can be imported using the id, e.g.

        ```sh
        $ pulumi import tencentcloud:Ssl/updateCertificateRecordRollbackOperation:UpdateCertificateRecordRollbackOperation update_certificate_record_rollback update_certificate_record_rollback_id
        ```

        :param str resource_name: The name of the resource.
        :param UpdateCertificateRecordRollbackOperationArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(UpdateCertificateRecordRollbackOperationArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 deploy_record_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = UpdateCertificateRecordRollbackOperationArgs.__new__(UpdateCertificateRecordRollbackOperationArgs)

            __props__.__dict__["deploy_record_id"] = deploy_record_id
        super(UpdateCertificateRecordRollbackOperation, __self__).__init__(
            'tencentcloud:Ssl/updateCertificateRecordRollbackOperation:UpdateCertificateRecordRollbackOperation',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            deploy_record_id: Optional[pulumi.Input[str]] = None) -> 'UpdateCertificateRecordRollbackOperation':
        """
        Get an existing UpdateCertificateRecordRollbackOperation resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] deploy_record_id: Deployment record ID to be rolled back.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _UpdateCertificateRecordRollbackOperationState.__new__(_UpdateCertificateRecordRollbackOperationState)

        __props__.__dict__["deploy_record_id"] = deploy_record_id
        return UpdateCertificateRecordRollbackOperation(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="deployRecordId")
    def deploy_record_id(self) -> pulumi.Output[Optional[str]]:
        """
        Deployment record ID to be rolled back.
        """
        return pulumi.get(self, "deploy_record_id")

