# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['OwnershipVerifyArgs', 'OwnershipVerify']

@pulumi.input_type
class OwnershipVerifyArgs:
    def __init__(__self__, *,
                 domain: pulumi.Input[str]):
        """
        The set of arguments for constructing a OwnershipVerify resource.
        :param pulumi.Input[str] domain: Verify domain name.
        """
        pulumi.set(__self__, "domain", domain)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Input[str]:
        """
        Verify domain name.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: pulumi.Input[str]):
        pulumi.set(self, "domain", value)


@pulumi.input_type
class _OwnershipVerifyState:
    def __init__(__self__, *,
                 domain: Optional[pulumi.Input[str]] = None,
                 result: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering OwnershipVerify resources.
        :param pulumi.Input[str] domain: Verify domain name.
        :param pulumi.Input[str] result: When the verification result is failed, this field will return the reason.
        :param pulumi.Input[str] status: Ownership verification results. `success`: verification successful; `fail`: verification failed.
        """
        if domain is not None:
            pulumi.set(__self__, "domain", domain)
        if result is not None:
            pulumi.set(__self__, "result", result)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def domain(self) -> Optional[pulumi.Input[str]]:
        """
        Verify domain name.
        """
        return pulumi.get(self, "domain")

    @domain.setter
    def domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "domain", value)

    @property
    @pulumi.getter
    def result(self) -> Optional[pulumi.Input[str]]:
        """
        When the verification result is failed, this field will return the reason.
        """
        return pulumi.get(self, "result")

    @result.setter
    def result(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "result", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Ownership verification results. `success`: verification successful; `fail`: verification failed.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)


class OwnershipVerify(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to create a teo ownership_verify

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ownership_verify = tencentcloud.teo.OwnershipVerify("ownershipVerify", domain="qq.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Verify domain name.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: OwnershipVerifyArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to create a teo ownership_verify

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import tencentcloud_iac_pulumi as tencentcloud

        ownership_verify = tencentcloud.teo.OwnershipVerify("ownershipVerify", domain="qq.com")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param OwnershipVerifyArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(OwnershipVerifyArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 domain: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = OwnershipVerifyArgs.__new__(OwnershipVerifyArgs)

            if domain is None and not opts.urn:
                raise TypeError("Missing required property 'domain'")
            __props__.__dict__["domain"] = domain
            __props__.__dict__["result"] = None
            __props__.__dict__["status"] = None
        super(OwnershipVerify, __self__).__init__(
            'tencentcloud:Teo/ownershipVerify:OwnershipVerify',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            domain: Optional[pulumi.Input[str]] = None,
            result: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None) -> 'OwnershipVerify':
        """
        Get an existing OwnershipVerify resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] domain: Verify domain name.
        :param pulumi.Input[str] result: When the verification result is failed, this field will return the reason.
        :param pulumi.Input[str] status: Ownership verification results. `success`: verification successful; `fail`: verification failed.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _OwnershipVerifyState.__new__(_OwnershipVerifyState)

        __props__.__dict__["domain"] = domain
        __props__.__dict__["result"] = result
        __props__.__dict__["status"] = status
        return OwnershipVerify(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def domain(self) -> pulumi.Output[str]:
        """
        Verify domain name.
        """
        return pulumi.get(self, "domain")

    @property
    @pulumi.getter
    def result(self) -> pulumi.Output[str]:
        """
        When the verification result is failed, this field will return the reason.
        """
        return pulumi.get(self, "result")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Ownership verification results. `success`: verification successful; `fail`: verification failed.
        """
        return pulumi.get(self, "status")

