# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetGroupConfigReleaseResult',
    'AwaitableGetGroupConfigReleaseResult',
    'get_group_config_release',
    'get_group_config_release_output',
]

@pulumi.output_type
class GetGroupConfigReleaseResult:
    """
    A collection of values returned by getGroupConfigRelease.
    """
    def __init__(__self__, group_id=None, id=None, result_output_file=None, results=None):
        if group_id and not isinstance(group_id, str):
            raise TypeError("Expected argument 'group_id' to be a str")
        pulumi.set(__self__, "group_id", group_id)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if results and not isinstance(results, list):
            raise TypeError("Expected argument 'results' to be a list")
        pulumi.set(__self__, "results", results)

    @property
    @pulumi.getter(name="groupId")
    def group_id(self) -> str:
        """
        Configuration item release group ID.Note: This field may return null, which means no valid value was found.
        """
        return pulumi.get(self, "group_id")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter
    def results(self) -> Sequence['outputs.GetGroupConfigReleaseResultResult']:
        """
        Information related to the deployment group release.Note: This field may return null, which means no valid value was found.
        """
        return pulumi.get(self, "results")


class AwaitableGetGroupConfigReleaseResult(GetGroupConfigReleaseResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetGroupConfigReleaseResult(
            group_id=self.group_id,
            id=self.id,
            result_output_file=self.result_output_file,
            results=self.results)


def get_group_config_release(group_id: Optional[str] = None,
                             result_output_file: Optional[str] = None,
                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetGroupConfigReleaseResult:
    """
    Use this data source to query detailed information of tsf group_config_release

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_config_release = tencentcloud.Tsf.get_group_config_release(group_id="group-yrjkln9v")
    ```
    <!--End PulumiCodeChooser -->


    :param str group_id: groupId.
    :param str result_output_file: Used to save results.
    """
    __args__ = dict()
    __args__['groupId'] = group_id
    __args__['resultOutputFile'] = result_output_file
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Tsf/getGroupConfigRelease:getGroupConfigRelease', __args__, opts=opts, typ=GetGroupConfigReleaseResult).value

    return AwaitableGetGroupConfigReleaseResult(
        group_id=pulumi.get(__ret__, 'group_id'),
        id=pulumi.get(__ret__, 'id'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        results=pulumi.get(__ret__, 'results'))


@_utilities.lift_output_func(get_group_config_release)
def get_group_config_release_output(group_id: Optional[pulumi.Input[str]] = None,
                                    result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetGroupConfigReleaseResult]:
    """
    Use this data source to query detailed information of tsf group_config_release

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud

    group_config_release = tencentcloud.Tsf.get_group_config_release(group_id="group-yrjkln9v")
    ```
    <!--End PulumiCodeChooser -->


    :param str group_id: groupId.
    :param str result_output_file: Used to save results.
    """
    ...
