# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetProcedureTemplatesResult',
    'AwaitableGetProcedureTemplatesResult',
    'get_procedure_templates',
    'get_procedure_templates_output',
]

@pulumi.output_type
class GetProcedureTemplatesResult:
    """
    A collection of values returned by getProcedureTemplates.
    """
    def __init__(__self__, id=None, name=None, result_output_file=None, sub_app_id=None, template_lists=None, type=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if result_output_file and not isinstance(result_output_file, str):
            raise TypeError("Expected argument 'result_output_file' to be a str")
        pulumi.set(__self__, "result_output_file", result_output_file)
        if sub_app_id and not isinstance(sub_app_id, int):
            raise TypeError("Expected argument 'sub_app_id' to be a int")
        pulumi.set(__self__, "sub_app_id", sub_app_id)
        if template_lists and not isinstance(template_lists, list):
            raise TypeError("Expected argument 'template_lists' to be a list")
        pulumi.set(__self__, "template_lists", template_lists)
        if type and not isinstance(type, str):
            raise TypeError("Expected argument 'type' to be a str")
        pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Task flow name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="resultOutputFile")
    def result_output_file(self) -> Optional[str]:
        return pulumi.get(self, "result_output_file")

    @property
    @pulumi.getter(name="subAppId")
    def sub_app_id(self) -> Optional[int]:
        return pulumi.get(self, "sub_app_id")

    @property
    @pulumi.getter(name="templateLists")
    def template_lists(self) -> Sequence['outputs.GetProcedureTemplatesTemplateListResult']:
        """
        A list of adaptive dynamic streaming templates. Each element contains the following attributes:
        """
        return pulumi.get(self, "template_lists")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Template type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
        """
        return pulumi.get(self, "type")


class AwaitableGetProcedureTemplatesResult(GetProcedureTemplatesResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetProcedureTemplatesResult(
            id=self.id,
            name=self.name,
            result_output_file=self.result_output_file,
            sub_app_id=self.sub_app_id,
            template_lists=self.template_lists,
            type=self.type)


def get_procedure_templates(name: Optional[str] = None,
                            result_output_file: Optional[str] = None,
                            sub_app_id: Optional[int] = None,
                            type: Optional[str] = None,
                            opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetProcedureTemplatesResult:
    """
    Use this data source to query detailed information of VOD procedure templates.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_procedure_template = tencentcloud.vod.ProcedureTemplate("fooProcedureTemplate",
        comment="test",
        media_process_task=tencentcloud.vod.ProcedureTemplateMediaProcessTaskArgs(
            adaptive_dynamic_streaming_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskAdaptiveDynamicStreamingTaskListArgs(
                definition=tencentcloud_vod_adaptive_dynamic_streaming_template["foo"]["id"],
            )],
            snapshot_by_time_offset_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskSnapshotByTimeOffsetTaskListArgs(
                definition=tencentcloud_vod_snapshot_by_time_offset_template["foo"]["id"],
                ext_time_offset_lists=["3.5s"],
            )],
            image_sprite_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskImageSpriteTaskListArgs(
                definition=tencentcloud_vod_image_sprite_template["foo"]["id"],
            )],
        ))
    foo_procedure_templates = tencentcloud.Vod.get_procedure_templates_output(type="Custom",
        name=foo_procedure_template.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: Name of procedure template.
    :param str result_output_file: Used to save results.
    :param int sub_app_id: Subapplication ID in VOD. If you need to access a resource in a subapplication, enter the subapplication ID in this field; otherwise, leave it empty.
    :param str type: Template type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['resultOutputFile'] = result_output_file
    __args__['subAppId'] = sub_app_id
    __args__['type'] = type
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('tencentcloud:Vod/getProcedureTemplates:getProcedureTemplates', __args__, opts=opts, typ=GetProcedureTemplatesResult).value

    return AwaitableGetProcedureTemplatesResult(
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        result_output_file=pulumi.get(__ret__, 'result_output_file'),
        sub_app_id=pulumi.get(__ret__, 'sub_app_id'),
        template_lists=pulumi.get(__ret__, 'template_lists'),
        type=pulumi.get(__ret__, 'type'))


@_utilities.lift_output_func(get_procedure_templates)
def get_procedure_templates_output(name: Optional[pulumi.Input[Optional[str]]] = None,
                                   result_output_file: Optional[pulumi.Input[Optional[str]]] = None,
                                   sub_app_id: Optional[pulumi.Input[Optional[int]]] = None,
                                   type: Optional[pulumi.Input[Optional[str]]] = None,
                                   opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetProcedureTemplatesResult]:
    """
    Use this data source to query detailed information of VOD procedure templates.

    ## Example Usage

    <!--Start PulumiCodeChooser -->
    ```python
    import pulumi
    import pulumi_tencentcloud as tencentcloud
    import tencentcloud_iac_pulumi as tencentcloud

    foo_procedure_template = tencentcloud.vod.ProcedureTemplate("fooProcedureTemplate",
        comment="test",
        media_process_task=tencentcloud.vod.ProcedureTemplateMediaProcessTaskArgs(
            adaptive_dynamic_streaming_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskAdaptiveDynamicStreamingTaskListArgs(
                definition=tencentcloud_vod_adaptive_dynamic_streaming_template["foo"]["id"],
            )],
            snapshot_by_time_offset_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskSnapshotByTimeOffsetTaskListArgs(
                definition=tencentcloud_vod_snapshot_by_time_offset_template["foo"]["id"],
                ext_time_offset_lists=["3.5s"],
            )],
            image_sprite_task_lists=[tencentcloud.vod.ProcedureTemplateMediaProcessTaskImageSpriteTaskListArgs(
                definition=tencentcloud_vod_image_sprite_template["foo"]["id"],
            )],
        ))
    foo_procedure_templates = tencentcloud.Vod.get_procedure_templates_output(type="Custom",
        name=foo_procedure_template.id)
    ```
    <!--End PulumiCodeChooser -->


    :param str name: Name of procedure template.
    :param str result_output_file: Used to save results.
    :param int sub_app_id: Subapplication ID in VOD. If you need to access a resource in a subapplication, enter the subapplication ID in this field; otherwise, leave it empty.
    :param str type: Template type filter. Valid values: `Preset`, `Custom`. `Preset`: preset template; `Custom`: custom template.
    """
    ...
